<?php
if(!defined("IN_MYBB"))
{
    die("You Cannot Access This File Directly. Please Make Sure IN_MYBB Is Defined.");
}

/*Hooks*/
$plugins->add_hook('insert_register_vorlage_end', 'hp_listen_register');
$plugins->add_hook('member_do_register_end', 'hp_listen_register');
$plugins->add_hook('wobplugin_edit_end', 'hp_listen_register');
$plugins->add_hook('global_start', 'wobgroup_global');
$plugins->add_hook('usercp_do_profile_start', 'hp_listen_listcheck');



function hp_listen_info()
{
	global $lang;
	$lang->load('hp_listen');
	return array
	(
        "name"  => $lang->hp_listen_name,
        "description"=> $lang->hp_listen_desc,
        "website"        => "http://ft.asthelon.de",
        "author"        => "Celine Geneau",
        "authorsite"    => "http://ft.asthelon.de",
        "version"        => "1.0",
        "guid"             => "",
        "compatibility" => "18*"
    );
} 

function hp_listen_activate()
{
	global $db, $cache;
	
	
	$plugins_cache = $cache->read("plugins");
	if (!isset($plugins_cache['active']['hp_wob']))
	{
		global $page, $lang;
		$lang->load('hp_listen');
		$page->output_confirm_action('index.php?module=config-plugins&action=deactivate&uninstall=1&plugin=hp_wob', $lang->hp_listen_activate_message, $lang->hp_listen_activate);
	}
	
	$dirName='../admin/modules';
	$my_dir="multifields";
	
	$alledateien = scandir($dirName);
	
	if (!in_array($my_dir, $alledateien))
	{
		mkdir($dirName."/".$my_dir, 0777, true);
	}

	$phpname[0]=$dirName.'/'.$my_dir.'/settings.php';
	$phpinhalt[0]='<?php
/**
 * MyBB 1.8
 * Copyright 2014 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybb.com
 * License: http://www.mybb.com/about/license
 *
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

$page->add_breadcrumb_item($lang->multifields_settings, "index.php?module=multifields-settings&amp;action={$mybb->input[\'action\']}");

$lang->load(\'multifields_settings\');

if($mybb->input[\'action\'] == "avas")
{
	$sub_tabs[\'multifields_avas\'] = array(
		\'title\' => $lang->avas,
		\'link\' => "index.php?module=multifields-settings&amp;action=avas",
		\'description\' => $lang->avas_desc
	);
	
	$mybb->input[\'action\'] = "avas";
}
else if($mybb->input[\'action\'] == "spezials")
{
	$sub_tabs[\'multifields_spezials\'] = array(
		\'title\' => $lang->spezials,
		\'link\' => "index.php?module=multifields-settings&amp;action=spezials",
		\'description\' => $lang->spezials_desc
	);
	
	$mybb->input[\'action\'] = "spezials";
}
else
{
	$sub_tabs[\'multifields_quidditch\'] = array(
		\'title\' => $lang->quidditch,
		\'link\' => "index.php?module=multifields-settings&amp;action=quidditch",
		\'description\' => $lang->quidditch_desc
	);
	
	$mybb->input[\'action\'] = "quidditch";
}

if($mybb->input[\'action\'] == "avas")
{
	$query = $db->simple_select("quidditch", "*", "");
	$multifields = $db->fetch_array($query);

	if($mybb->request_method == "post")
	{
		$avatars=$mybb->get_input(\'test\', MyBB::INPUT_ARRAY);
		
		$db->delete_query("multiava", "");
		
		foreach($avatars as $name => $value)
		{
			$insert_array = array(
				\'avaname\' => $db->escape_string($name),
				\'anzahl\' => $value
			);
			$db->insert_query(\'multiava\', $insert_array);
			
			// Log admin action
			log_admin_action("multiava", htmlspecialchars_uni($name), $value);
		}
		
		

		flash_message($lang->success_multifields_ava_updated, \'success\');
		admin_redirect("index.php?module=multifields-settings&amp;action=avas");
	}

	$page->add_breadcrumb_item($lang->avas);
	$page->output_header($lang->multifields_settings." - ".$lang->avas);

	$sub_tabs[\'multifields_avas\'] = array(
		\'title\' => $lang->avas,
		\'link\' => "index.php?module=multifields-settings&amp;action=avas",
		\'description\' => $lang->avas_desc
	);
	$sub_tabs[\'multifields_spezials\'] = array(
		\'title\' => $lang->spezials,
		\'link\' => "index.php?module=multifields-settings&amp;action=spezials",
		\'description\' => $lang->spezials_desc
	);
	$sub_tabs[\'multifields_quidditch\'] = array(
		\'title\' => $lang->quidditch,
		\'link\' => "index.php?module=multifields-settings&amp;action=quidditch",
		\'description\' => $lang->quidditch_desc
	);

	$page->output_nav_tabs($sub_tabs, \'multifields_avas\');
	$form = new Form("index.php?module=multifields-setting&amp;action=avas", "post");


	if($errors)
	{
		$page->output_inline_error($errors);
	}
	else
	{
		$mybb->input = array_merge($mybb->input, $multifields);
	}
	
	$form_container = new FormContainer($lang->multifields_ava_settings);
	
	$form_container->output_row_header($lang->avaname, array("class" => "align_center"));
	$form_container->output_row_header($lang->avaanzahl, array("class" => "align_center"));
	$form_container->output_row_header("", array("class" => "align_center"));
	$form_container->output_row_header($lang->avaname, array("class" => "align_center"));
	$form_container->output_row_header($lang->avaanzahl, array("class" => "align_center"));
	
	$query = $db->simple_select("userfields", "*", "fid21 IS NOT NULL AND NOT fid21 = \'\'");
	$i=0;
	while($row=$db->fetch_array($query))
	{
		$avaname=$row[\'fid21\'];
		if($taken[$avaname]!=1)
		{
			$aquery = $db->simple_select("multiava", "*", "avaname=\'{$avaname}\'");
			$multiavatest = $db->fetch_array($aquery);
			$selected=$multiavatest[\'anzahl\'];
		
			$list[0]="Einzelkind";
			$list[2]="Zwilling";
			$list[3]="Drilling";
			$list[4]="Vierling";
			
			$form_container->output_cell($avaname, array("class" => "align_center"));
			$form_container->output_cell($form->generate_select_box(\'test[\'.$avaname.\']\', $list, $selected, array(\'id\' => \'test[\'.$avaname.\']\')), array("class" => "align_center"));
			
			$i++;
			if($i==2)
			{	
				$i=0;
				$form_container->construct_row();
			}
			else
			{
				$form_container->output_cell("", array("class" => "align_center"));
			}
			$taken[$avaname]=1;
		}
	}
	$form_container->end();

	$buttons[] = $form->generate_submit_button($lang->save_multifields_settings);

	$form->output_submit_wrapper($buttons);
	$form->end();

	$page->output_footer();

}

if($mybb->input[\'action\'] == "spezials")
{
	$query = $db->simple_select("quidditch", "*", "");
	$multifields = $db->fetch_array($query);

	if($mybb->request_method == "post")
	{
		$spezials=$mybb->get_input(\'test\', MyBB::INPUT_ARRAY);
		
		$db->delete_query("spezials", "");
		
		foreach($spezials as $name => $value)
		{
			$insert_array = array(
				\'spezial\' => $db->escape_string($name),
				\'anzahl\' => $value
			);
			$db->insert_query(\'spezials\', $insert_array);
			
			// Log admin action
			log_admin_action("spezials", htmlspecialchars_uni($name), $value);
		}
		
		

		flash_message($lang->success_multifields_spezials_updated, \'success\');
		admin_redirect("index.php?module=multifields-settings&amp;action=spezials");
	}

	$page->add_breadcrumb_item($lang->spezials);
	$page->output_header($lang->multifields_settings." - ".$lang->spezials);

	$sub_tabs[\'multifields_avas\'] = array(
		\'title\' => $lang->avas,
		\'link\' => "index.php?module=multifields-settings&amp;action=avas",
		\'description\' => $lang->avas_desc
	);
	$sub_tabs[\'multifields_spezials\'] = array(
		\'title\' => $lang->spezials,
		\'link\' => "index.php?module=multifields-settings&amp;action=spezials",
		\'description\' => $lang->spezials_desc
	);
	$sub_tabs[\'multifields_quidditch\'] = array(
		\'title\' => $lang->quidditch,
		\'link\' => "index.php?module=multifields-settings&amp;action=quidditch",
		\'description\' => $lang->quidditch_desc
	);

	$page->output_nav_tabs($sub_tabs, \'multifields_spezials\');
	$form = new Form("index.php?module=multifields-setting&amp;action=spezials", "post");


	if($errors)
	{
		$page->output_inline_error($errors);
	}
	else
	{
		$mybb->input = array_merge($mybb->input, $multifields);
	}
	
	$form_container = new FormContainer($lang->multifields_ava_settings);
	
	$form_container->output_row_header($lang->spezialname, array("class" => "align_center"));
	$form_container->output_row_header($lang->spezialanzahl, array("class" => "align_center"));
	$form_container->output_row_header("", array("class" => "align_center"));
	$form_container->output_row_header($lang->spezialname, array("class" => "align_center"));
	$form_container->output_row_header($lang->spezialanzahl, array("class" => "align_center"));
	
	$squery = $db->simple_select("profilefields", "*", "fid=\'5\'");
	$spezialrow = $db->fetch_array($squery);
	
	$spezials=nl2br($spezialrow[\'type\']);
	
	$arr=explode(\'<br />\',$spezials);
	
	$u=1;
	$i=0;
	while($u<count($arr))
	{
		$spezialname=trim($arr[$u]);
		
		if($taken[$spezialname]!=1)
		{
			
			$aquery = $db->simple_select("spezials", "*", "spezial=\'{$spezialname}\'");
			$multiavatest = $db->fetch_array($aquery);
			$selected=$multiavatest[\'anzahl\'];
			
			$form_container->output_cell($spezialname, array("class" => "align_center"));
			$form_container->output_cell($form->generate_numeric_field("test[{$spezialname}]", $selected, array(\'id\' => \'disporder\', \'style\' => \'width: 80%\', \'min\' => 0)));
			
			$u++;
			$i++;
			if($i==2)
			{	
				$i=0;
				$form_container->construct_row();
			}
			else
			{
				$form_container->output_cell("", array("class" => "align_center"));
			}
			$taken[$spezialname]=1;
		}
	}
	$form_container->end();

	$buttons[] = $form->generate_submit_button($lang->save_multifields_settings);

	$form->output_submit_wrapper($buttons);
	$form->end();

	$page->output_footer();

}

if($mybb->input[\'action\'] == "quidditch")
{
	$query = $db->simple_select("quidditch", "*", "");
	$multifields = $db->fetch_array($query);

	if($mybb->request_method == "post")
	{
		$quidditch=$mybb->get_input(\'test\', MyBB::INPUT_ARRAY);
		
		$db->delete_query("quidditch", "");
		
		foreach($quidditch as $name => $value)
		{
			$insert_array = array(
				\'position\' => $db->escape_string($name),
				\'anzahl\' => $value
			);
			$db->insert_query(\'quidditch\', $insert_array);
			
			// Log admin action
			log_admin_action("quidditch", htmlspecialchars_uni($name), $value);
		}
		
		

		flash_message($lang->success_multifields_quidditch_updated, \'success\');
		admin_redirect("index.php?module=multifields-settings&amp;action=quidditch");
	}

	$page->add_breadcrumb_item($lang->quidditch);
	$page->output_header($lang->multifields_settings." - ".$lang->quidditch);

	$sub_tabs[\'multifields_avas\'] = array(
		\'title\' => $lang->avas,
		\'link\' => "index.php?module=multifields-settings&amp;action=avas",
		\'description\' => $lang->avas_desc
	);
	$sub_tabs[\'multifields_spezials\'] = array(
		\'title\' => $lang->spezials,
		\'link\' => "index.php?module=multifields-settings&amp;action=spezials",
		\'description\' => $lang->spezials_desc
	);
	$sub_tabs[\'multifields_quidditch\'] = array(
		\'title\' => $lang->quidditch,
		\'link\' => "index.php?module=multifields-settings&amp;action=quidditch",
		\'description\' => $lang->quidditch_desc
	);

	$page->output_nav_tabs($sub_tabs, \'multifields_quidditch\');
	$form = new Form("index.php?module=multifields-setting&amp;action=quidditch", "post");


	if($errors)
	{
		$page->output_inline_error($errors);
	}
	else
	{
		$mybb->input = array_merge($mybb->input, $multifields);
	}
	
	$form_container = new FormContainer($lang->multifields_ava_settings);
	
	$form_container->output_row_header($lang->posname, array("class" => "align_center"));
	$form_container->output_row_header($lang->posanzahl, array("class" => "align_center"));
	$form_container->output_row_header("", array("class" => "align_center"));
	$form_container->output_row_header($lang->posname, array("class" => "align_center"));
	$form_container->output_row_header($lang->posanzahl, array("class" => "align_center"));
	
	$squery = $db->simple_select("profilefields", "*", "fid=\'18\'");
	$spezialrow = $db->fetch_array($squery);
	
	$positions=nl2br($spezialrow[\'type\']);
	
	$arr=explode(\'<br />\',$positions);
	
	$u=1;
	$i=0;
	while($u<count($arr))
	{
		$posname=trim($arr[$u]);
		
		if($taken[$posname]!=1)
		{
			
			$aquery = $db->simple_select("quidditch", "*", "position=\'{$posname}\'");
			$multiavatest = $db->fetch_array($aquery);
			$selected=$multiavatest[\'anzahl\'];
			
			$form_container->output_cell($posname, array("class" => "align_center"));
			$form_container->output_cell($form->generate_numeric_field("test[{$posname}]", $selected, array(\'id\' => \'disporder\', \'style\' => \'width: 80%\', \'min\' => 0)));
			
			$u++;
			$i++;
			if($i==2)
			{	
				$i=0;
				$form_container->construct_row();
			}
			else
			{
				$form_container->output_cell("", array("class" => "align_center"));
			}
			$taken[$posname]=1;
		}
	}
	
	if($i=!0) $form_container->construct_row();
	$form_container->end();

	$buttons[] = $form->generate_submit_button($lang->save_multifields_settings);

	$form->output_submit_wrapper($buttons);
	$form->end();

	$page->output_footer();
}';

	$phpname[1]=$dirName.'/'.$my_dir.'/module_meta.php';
	$phpinhalt[1]='<?php
/**
 * MyBB 1.8
 * Copyright 2014 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybb.com
 * License: http://www.mybb.com/about/license
 *
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

/**
 * @return bool true
 */
function multifields_meta()
{
	global $page, $lang, $plugins;

	$sub_menu = array();
	$sub_menu[\'10\'] = array("id" => "multifields_avas", "title" => $lang->avas, "link" => "index.php?module=multifields-settings&action=avas");
	$sub_menu[\'20\'] = array("id" => "multifields_spezials", "title" => $lang->spezials, "link" => "index.php?module=multifields-settings&action=spezials");
	$sub_menu[\'30\'] = array("id" => "multifields_quidditch", "title" => $lang->quidditch, "link" => "index.php?module=multifields-settings&action=quidditch");
	
	$sub_menu = $plugins->run_hooks("admin_multifields_menu", $sub_menu);

	$page->add_menu_item($lang->multifields_settings, "avas", "index.php?module=multifields-settings&action=avas", 80, $sub_menu);
	return true;
}

/**
 * @param string $action
 *
 * @return string
 */
function multifields_action_handler($action)
{
	global $page, $lang, $plugins;

	$page->active_module = "multifields";

	$actions = array(
		\'multifields\' => array(\'multifields\' => \'multifields\', \'file\' => \'settings.php\'),
	);

	$actions = $plugins->run_hooks("admin_multifields_action_handler", $actions);

	if(isset($actions[$action]))
	{
		$page->active_action = "multifields_avas";
		return "settings.php";
	}
	else
	{
		$page->active_action = "multifields_spezials";
		return "settings.php";
	}
}
?>';

	$my_dir="seriencharas";
	
	$alledateien = scandir($dirName);
	
	if (!in_array($my_dir, $alledateien))
	{
		mkdir($dirName."/".$my_dir, 0777, true);
	}
	
	$phpname[2]=$dirName.'/'.$my_dir.'/settings.php';
	$phpinhalt[2]='<?php
/**
 * MyBB 1.8
 * Copyright 2014 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybb.com
 * License: http://www.mybb.com/about/license
 *
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

$page->add_breadcrumb_item($lang->seriencharas_settings, "index.php?module=seriencharas-settings&amp;action={$mybb->input[\'action\']}");

$lang->load(\'seriencharas_settings\');

if($mybb->input[\'action\'] == "edit")
{
	$sub_tabs[\'seriencharas\'] = array(
		\'title\' => $lang->seriencharas,
		\'link\' => "index.php?module=seriencharas-settings",
		\'description\' => $lang->seriencharas_desc
	);
	
	$sub_tabs[\'seriencharas_add\'] = array(
		\'title\' => $lang->seriencharas_add,
		\'link\' => "index.php?module=seriencharas-settings&amp;action=add",
		\'description\' => $lang->seriencharas_desc
	);
	
	$mybb->input[\'action\'] = "edit";
}
else 
if($mybb->input[\'action\'] == "add")
{
	$sub_tabs[\'seriencharas\'] = array(
		\'title\' => $lang->seriencharas,
		\'link\' => "index.php?module=seriencharas-settings",
		\'description\' => $lang->seriencharas_desc
	);
	
	$sub_tabs[\'seriencharas_add\'] = array(
		\'title\' => $lang->seriencharas_add,
		\'link\' => "index.php?module=seriencharas-settings&amp;action=add",
		\'description\' => $lang->seriencharas_desc
	);
	
	$mybb->input[\'action\'] = "add";
}
else if($mybb->input[\'action\'] == "delete")
{
	$sub_tabs[\'seriencharas\'] = array(
		\'title\' => $lang->seriencharas,
		\'link\' => "index.php?module=seriencharas-settings",
		\'description\' => $lang->seriencharas_desc
	);
	
	$sub_tabs[\'seriencharas_add\'] = array(
		\'title\' => $lang->seriencharas_add,
		\'link\' => "index.php?module=seriencharas-settings&amp;action=add",
		\'description\' => $lang->seriencharas_desc
	);
	
	$mybb->input[\'action\'] = "delete";
}
else
{
	$sub_tabs[\'seriencharas\'] = array(
		\'title\' => $lang->seriencharas,
		\'link\' => "index.php?module=seriencharas-settings",
		\'description\' => $lang->seriencharas_desc
	);
	
	$sub_tabs[\'seriencharas_add\'] = array(
		\'title\' => $lang->seriencharas_add,
		\'link\' => "index.php?module=seriencharas-settings&amp;action=add",
		\'description\' => $lang->seriencharas_desc
	);
	
	$mybb->input[\'action\'] = "edit";
}

if($mybb->input[\'action\'] == "edit")
{
	$query = $db->simple_select("seriencharas", "*", "");
	$seriencharas = $db->fetch_array($query);

	if($mybb->request_method == "post")
	{
		$seriencharas=$mybb->get_input(\'test\', MyBB::INPUT_ARRAY);
		
		$db->delete_query("seriencharas", "");
		
		foreach($seriencharas as $name => $value)
		{
			$insert_array = array(
				"name" => $db->escape_string($name),
				"username" => $db->escape_string($value[\'username\']),
				"age" => $value[\'age\'],
				"gender" => $value[\'gender\'],
				"gruppe" => $value[\'gruppe\']
			);
			$db->insert_query(\'seriencharas\', $insert_array);
			
			// Log admin action
			log_admin_action("seriencharas", htmlspecialchars_uni($name), $value);
		}
		
		

		flash_message($lang->success_seriencharas_updated, \'success\');
		admin_redirect("index.php?module=seriencharas-settings&amp;action=edit");
	}

	$page->add_breadcrumb_item($lang->seriencharas);
	$page->output_header($lang->seriencharas_settings." - ".$lang->seriencharas);

	$sub_tabs[\'seriencharas\'] = array(
		\'title\' => $lang->seriencharas,
		\'link\' => "index.php?module=seriencharas-settings",
		\'description\' => $lang->seriencharas_desc
	);
	
	$sub_tabs[\'seriencharas_add\'] = array(
		\'title\' => $lang->seriencharas_add,
		\'link\' => "index.php?module=seriencharas-settings&amp;action=add",
		\'description\' => $lang->seriencharas_desc
	);

	$page->output_nav_tabs($sub_tabs, \'seriencharas\');
	$form = new Form("index.php?module=seriencharas-setting&amp;action=edit", "post");


	if($errors)
	{
		$page->output_inline_error($errors);
	}
	
	$form_container = new FormContainer($lang->seriencharas_settings);
	
	$form_container->output_row_header($lang->Name, array("class" => "align_center"));
	$form_container->output_row_header($lang->Username, array("class" => "align_center"));
	$form_container->output_row_header($lang->Alter, array("class" => "align_center"));
	$form_container->output_row_header($lang->Geschlecht, array("class" => "align_center"));
	$form_container->output_row_header($lang->Gruppe, array("class" => "align_center"));
	$form_container->output_row_header($lang->Deleten, array("class" => "align_center"));
	
	$i=0;
	$squery = $db->simple_select("seriencharas", "*", "");
	while($row=$db->fetch_array($squery))
	{
		$charaname=trim($row[\'name\']);
		if($taken[$charaname]!=1)
		{
			$charausername=trim($row[\'username\']);
			$charaalter=trim($row[\'age\']);
			$charagender=trim($row[\'gender\']);
			$charagruppe=trim($row[\'gruppe\']);
			
			$list[\'male\']="M&auml;nnlich";
			$list[\'female\']="Weiblich";
			
			$form_container->output_cell($charaname, array("class" => "align_center"));
			$form_container->output_cell($form->generate_text_box(\'test[\'.$charaname.\'][username]\', $charausername, array(\'id\' => \'test[\'.$charaname.\'][username]\')));
			$form_container->output_cell($form->generate_numeric_field("test[".$charaname."][age]", $charaalter, array(\'id\' => "test[".$charaname."][age]", \'style\' => \'width: 80%\', \'min\' => 0)));
			$form_container->output_cell($form->generate_select_box("test[".$charaname."][gender]", $list, $charagender, array(\'id\' => "test[".$charaname."][gender]")), array("class" => "align_center"));
			
			$hquery = $db->simple_select("profilefields", "*", "fid=13");
			$hrow=$db->fetch_array($hquery);
			
			$gquery = $db->simple_select("profilefields", "*", "fid=7");
			$grow=$db->fetch_array($gquery);
			
			$rrow[\'type\']=$grow[\'type\'].\'
	\'.$hrow[\'type\'];
			
			$gruppen=explode(\'<br />\',nl2br($rrow[\'type\']));
			foreach($gruppen as $group)
			{
				if(trim($group) != "select" && trim($group) != "multiselect") $nlist[trim($group)]=trim($group);
			}
			
			$form_container->output_cell($form->generate_select_box("test[".$charaname."][gruppe]", $nlist, $charagruppe, array(\'id\' => "test[".$charaname."][gruppe]")), array("class" => "align_center"));
			$form_container->output_cell(\'<a href="index.php?module=seriencharas-setting&amp;action=delete&amp;user=\'.$charaname.\'"><img src="styles/default/images/delete.gif"></a>\');
			
			$form_container->construct_row();
			
			$taken[$charaname]=1;
		}
	}
	$form_container->end();

	$buttons[] = $form->generate_submit_button($lang->save_seriencharas_settings);

	$form->output_submit_wrapper($buttons);
	$form->end();

	$page->output_footer();

}

if($mybb->input[\'action\'] == "add")
{
	
	if($mybb->request_method == "post")
	{
		if(!trim($mybb->input[\'name\']))
		{
			$errors[] = $lang->error_missing_name;
		}
		if(!trim($mybb->input[\'username\']))
		{
			$errors[] = $lang->error_missing_usernama;
		}
		if(!trim($mybb->input[\'alter\']))
		{
			$errors[] = $lang->error_missing_altere;
		}
		
		$query = $db->simple_select("seriencharas", "*", "username=\'{$mybb->input[\'username\']}\'");
		$row=$db->fetch_array($query);
		if($row[\'username\'])
		{
			$errors[] = $lang->error_user_exists;
		}
		
		
		if(!$errors)
		{
			
			$insert_serienchara = array(
				"name" => $db->escape_string($mybb->input[\'name\']),
				"username" => $db->escape_string($mybb->input[\'username\']),
				"age" => $mybb->get_input(\'alter\', MyBB::INPUT_INT),
				"gender" => $db->escape_string($mybb->input[\'gender\']),
				"gruppe" => $db->escape_string($mybb->input[\'gruppe\'])
			);
			$db->insert_query("seriencharas", $insert_serienchara);
			
			// Log admin action
			log_admin_action("Seriencharas", htmlspecialchars_uni($mybb->input[\'name\']), htmlspecialchars_uni($mybb->input[\'usernama\']), htmlspecialchars_uni($mybb->input[\'alter\']), htmlspecialchars_uni($mybb->input[\'gender\']), htmlspecialchars_uni($mybb->input[\'gruppe\']));

			flash_message($lang->success_seriencharas_add, \'success\');
			admin_redirect("index.php?module=seriencharas-settings&amp;action=edit");
		}
	}
	
	
	$page->add_breadcrumb_item($lang->seriencharas_add);
	$page->output_header($lang->seriencharas_settings." - ".$lang->seriencharas_add);

	$sub_tabs[\'seriencharas\'] = array(
		\'title\' => $lang->seriencharas,
		\'link\' => "index.php?module=seriencharas-settings",
		\'description\' => $lang->seriencharas_desc
	);
	
	$sub_tabs[\'seriencharas_add\'] = array(
		\'title\' => $lang->seriencharas_add,
		\'link\' => "index.php?module=seriencharas-settings&amp;action=add",
		\'description\' => $lang->seriencharas_desc
	);

	$page->output_nav_tabs($sub_tabs, \'seriencharas_add\');
	$form = new Form("index.php?module=seriencharas-setting&amp;action=add", "post");


	if($errors)
	{
		$page->output_inline_error($errors);
	}
	
	$form_container = new FormContainer($lang->seriencharas_add);
	
	$form_container->output_row($lang->Name."<em>*</em>", $lang->Name_desc, $form->generate_text_box(\'name\', "", array(\'id\' => \'name\')), \'name\');
	$form_container->output_row($lang->Username."<em>*</em>", $lang->Username_desc, $form->generate_text_box(\'username\', "", array(\'id\' => \'username\')), \'username\');
	$form_container->output_row($lang->Alter, $lang->Alter_desc, $form->generate_numeric_field(\'alter\', \'\', array(\'id\' => \'alter\', \'min\' => 0)), \'alter\');
	
	$list[\'male\']="M&auml;nnlich";
	$list[\'female\']="Weiblich";
			
	$form_container->output_row($lang->Geschlecht, $lang->Geschlecht_desc, $form->generate_select_box(\'gender\', $list, "", array(\'id\' => \'gender\')), \'gender\');
	
	$hquery = $db->simple_select("profilefields", "*", "fid=13");
	$hrow=$db->fetch_array($hquery);
	
	$gquery = $db->simple_select("profilefields", "*", "fid=7");
	$grow=$db->fetch_array($gquery);
	
	$rrow[\'type\']=$grow[\'type\'].\'
	\'$hrow[\'type\'];
	
	$gruppen=explode(\'<br />\',nl2br($rrow[\'type\']));
	foreach($gruppen as $group)
	{
		if(trim($group) != "select" && trim($group) != "multiselect") $nlist[trim($group)]=trim($group);
	}
			
	$form_container->output_row($lang->Gruppe, $lang->Gruppe_desc, $form->generate_select_box(\'gruppe\', $nlist, "", array(\'id\' => \'gruppe\')), \'gruppe\');
	
	
	$form_container->end();
	$buttons[] = $form->generate_submit_button($lang->save_seriencharas_settings);
	
	$form->output_submit_wrapper($buttons);
	$form->end();
	$page->output_footer();
}

if($mybb->input[\'action\'] == "delete")
{
	if($mybb->request_method == "post")
	{
		if(!trim($mybb->input[\'charaname\']))
		{
			$errors[] = $lang->error_missing_user;
		}
		else $charaname=trim($mybb->input[\'charaname\']);
		
		if(!$errors)
		{
			$db->delete_query("seriencharas", "name=\'{$charaname}\'");
			
			
			// Log admin action
			log_admin_action("Seriencharas", htmlspecialchars_uni($charaname));

			flash_message($lang->success_seriencharas_delete, \'success\');
			admin_redirect("index.php?module=seriencharas-settings&amp;action=edit");
		}
	}
	
	$page->add_breadcrumb_item($lang->seriencharas_delete);
	$page->output_header($lang->seriencharas_settings." - ".$lang->seriencharas_delete);

	$sub_tabs[\'seriencharas\'] = array(
		\'title\' => $lang->seriencharas,
		\'link\' => "index.php?module=seriencharas-settings",
		\'description\' => $lang->seriencharas_desc
	);
	
	$sub_tabs[\'seriencharas_add\'] = array(
		\'title\' => $lang->seriencharas_add,
		\'link\' => "index.php?module=seriencharas-settings&amp;action=add",
		\'description\' => $lang->seriencharas_desc
	);

	$page->output_nav_tabs($sub_tabs, \'seriencharas_delete\');
	$form = new Form("index.php?module=seriencharas-setting&amp;action=delete", "post");
	
	if(!trim($mybb->input[\'user\']))
	{
		$errors[] = $lang->error_missing_user;
	}
	else $charaname=trim($mybb->input[\'user\']);
	
	if($errors)
	{
		$page->output_inline_error($errors);
	}

	$form_container = new FormContainer($lang->seriencharas_delete);
	$options[\'id\']="charaname";
	
	$question=$lang->delete_seriencharas_realy_delete;
	$question=str_replace(\'{$charaname}\',$charaname,$question);

	
	$form_container->output_row($question.$form->generate_hidden_field("charaname",$charaname,$options));
	
	$form_container->end();
	if(!$errors) $buttons[] = $form->generate_submit_button($lang->delete_seriencharas_settings);
	$buttons[] = \'<input type="button"  class="submit_button" value="\'.$lang->cancel_seriencharas_settings.\'" onClick="history.go(-1);return true;">\';
	
	$form->output_submit_wrapper($buttons);
	$form->end();
	$page->output_footer();
}

';
	
	$phpname[3]=$dirName.'/'.$my_dir.'/module_meta.php';
	$phpinhalt[3]='<?php
/**
 * MyBB 1.8
 * Copyright 2014 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybb.com
 * License: http://www.mybb.com/about/license
 *
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

/**
 * @return bool true
 */
function seriencharas_meta()
{
	global $page, $lang, $plugins;

	$sub_menu = array();
	$sub_menu[\'10\'] = array("id" => "settings", "title" => $lang->seriencharas, "link" => "index.php?module=seriencharas-settings&action=edit");
	
	$sub_menu = $plugins->run_hooks("admin_seriencharas_menu", $sub_menu);

	$page->add_menu_item($lang->seriencharas, "seriencharas", "index.php?module=seriencharas-settings&action=edit", 70, $sub_menu);
	return true;
}

/**
 * @param string $action
 *
 * @return string
 */
function seriencharas_action_handler($action)
{
	global $page, $lang, $plugins;

	$page->active_module = "seriencharas";

	$actions = array(
		\'seriencharas\' => array(\'seriencharas\' => \'seriencharas\', \'file\' => \'settings.php\'),
	);

	$actions = $plugins->run_hooks("admin_seriencharas_action_handler", $actions);

	if(isset($actions[$action]))
	{
		$page->active_action = "seriencharas";
		return "settings.php";
	}
	else
	{
		$page->active_action = "settings";
		return "settings.php";
	}
}
?>';

$i=0;
	$max=count($phpname);
	while($i<$max)
	{
		$filename=$phpname[$i];
		$inhalt=$phpinhalt[$i];
		
		$handle = fopen ($mybb->settings['bburl'].$filename, 'a+');
		fwrite ($handle, $inhalt);
		fclose ($handle);
		$i++;
	}
	
	/*Daten in PHP's ndern*/
	/*Pfad Deutsch-du*/
	$pfad[0]="../inc/languages/deutsch_du/datahandler_user.lang.php";
	$s[0]='$l[\'userdata_missing_required_profile_field\'] = \'Die Angabe im Feld "{1}" fehlt. Bitte korrigiere deine Eingabe.\';';
	$r[0]='$l[\'userdata_missing_required_profile_field\'] = \'Die Angabe im Feld "{1}" fehlt oder ist bereits vergeben. Bitte korrigiere deine Eingabe.\';';
	
	/*Pfad Deutsch-sie*/	
	$pfad[1]="../inc/languages/deutsch_sie/datahandler_user.lang.php";
	$s[1]='$l[\'userdata_missing_required_profile_field\'] = \'Die Angabe im Feld "{1}" fehlt. Bitte korrigieren Sie Ihre Eingabe.\';';
	$r[1]='$l[\'userdata_missing_required_profile_field\'] = \'Die Angabe im Feld "{1}" fehlt oder ist bereits vergeben. Bitte korrigieren Sie Ihre Eingabe.\';';
	
	/*Pfad english*/
	$pfad[2]="../inc/languages/english/datahandler_user.lang.php";
	$s[2]='$l[\'userdata_missing_required_profile_field\'] = \'You did not enter an option for the "{1}" field. Please fill in or select a value for this field.\';';
	$r[2]='$l[\'userdata_missing_required_profile_field\'] = \'You did not enter an option or enter an allready taken option for the "{1}" field. Please fill in or select a value for this field.\';';

	/*Icons als Grafik*/
	$pfad[2]="../inc/functions_post.php";
	$s[2]='$post[\'fieldvalue\'] = $parser->parse_message($post[$fieldfid], $field_parser_options);';
	$r[2]='if($fieldfid=="fid24") $post[$fieldfid]=\'<img src="\'.$post[$fieldfid].\'">\';
	
	$post[\'fieldvalue\'] = $parser->parse_message($post[$fieldfid], $field_parser_options);';
	
	/*Icons als Grafik*/
	$pfad[2]="../inc/functions_post.php";
	$s[2]='$customfieldval = $parser->parse_message($userfields[$field], $parser_options);';
	$r[2]='if($field=="fid24") $userfields[$field]=\'<img src="\'.$userfields[$field].\'">\';
	
	$customfieldval = $parser->parse_message($userfields[$field], $parser_options);';

	$i=0;
	$max=count($pfad);
	while($i<$max)
	{
		$datei=$pfad[$i];
		$search=$s[$i];
		$replace=$r[$i];
		
		$inhalt = file_get_contents($datei);
		$inhalt = str_replace($search,$replace,$inhalt);
	
		file_put_contents($datei,$inhalt);
		$i++;
	}

	
	/*neue PHP-Dateien erzeugen*/
	$phpname[0]='../listen.php';
	$phpinhalt[0]='<?php
   define("IN_MYBB", 1);
        require_once "./global.php";
        require_once MYBB_ROOT."inc/class_parser.php";
    add_breadcrumb("Listen", "listen.php");

$lang->load(\'hp_listen\');
$listenname=$lang->hp_listen_listenname;
	
if(!$mybb->input[\'action\'] || $mybb->input[\'action\']=="general")
{
	$title=$lang->hp_listen_title_main;
	$titleint=$lang->hp_listen_title_student;
	
	$avatare=$lang->hp_listen_title_avatare;
	$besonderheiten=$lang->hp_listen_title_besonderheiten;
	$beziehungsliste=$lang->hp_listen_title_beziehungsliste;
	$blutstatus=$lang->hp_listen_title_blutstatus;
	$charaktere=$lang->hp_listen_title_charaktere;
	$namen=$lang->hp_listen_title_namen;
	$patronus=$lang->hp_listen_title_patronus;
	$reinblut=$lang->hp_listen_title_reinblut;
	$gesinnung=$lang->hp_listen_title_gesinnung;
	$berufe=$lang->hp_listen_title_berufe;
	$zweitcharas=$lang->hp_listen_title_zweitcharas;
	$seriencharas=$lang->hp_listen_title_seriencharas;
	
    eval("\$page = \"".$templates->get("listen_main")."\";");
    output_page($page);
}

if($mybb->input[\'action\']=="student")
{
	$title=$lang->hp_listen_title_student;
	$titleext=$lang->hp_listen_title_main;
	
	$classes=$lang->hp_listen_title_classes;
	$kursliste=$lang->hp_listen_title_kursliste;
	$quidditch=$lang->hp_listen_title_quidditch;
	$clubs=$lang->hp_listen_title_clubs;
	$zeitung=$lang->hp_listen_title_zeitung;
	$band=$lang->hp_listen_title_band;
	$positionen=$lang->hp_listen_title_positionen;
	
	eval("\$page = \"".$templates->get("listen_student")."\";");
    output_page($page);
}

/*Zweitcharaktere*/	
if($mybb->input[\'action\']=="zweitcharas")
{
	$url="/accountlist.php";
	header("Location: ".$url);
	exit;
}

/*Avatare*/
if($mybb->input[\'action\']=="avatare")
{
	$title=$lang->hp_listen_title_avatare;
			
	$male=$lang->hp_listen_male;
	$female=$lang->hp_listen_female;
	
	$result=$db->query("
    SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid22, f.fid21 FROM ".TABLE_PREFIX."users u
    LEFT JOIN ".TABLE_PREFIX."userfields f
    ON u.uid = f.ufid
    WHERE f.fid21 IS NOT NULL
    AND f.fid21 <> \'\'"
    );
    while($row=$db->fetch_array($result))
    {
            $userid = $row[\'uid\'];
            $usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
            $usernamelink = build_profile_link($usernamecolor, $userid);

            $username = $usernamelink;

            $avatar= $row[\'fid21\'];
            $gender= $row[\'fid22\'];

            $test=$avatar{0};
            switch ($test)
			{
				case "A":
					$letter=\'1\';
					break;
				case "B":
					$letter=\'1\';
					break;
				case "C":
					$letter=\'1\';
					break;
				case "D":
					$letter=\'1\';
					break;
				case "E":
					$letter=\'1\';
					break;
				case "F":
					$letter=\'1\';
					break;
				case "G":
					$letter=\'2\';
					break;
				case "H":
					$letter=\'2\';
					break;
				case "I":
					$letter=\'2\';
					break;
				case "J":
					$letter=\'2\';
					break;
				case "K":
					$letter=\'2\';
					break;
				case "L":
					$letter=\'3\';
					break;
				case "M":
					$letter=\'3\';
					break;
				case "N":
					$letter=\'3\';
					break;
				case "O":
					$letter=\'3\';
					break;
				case "P":
					$letter=\'3\';
					break;
				case "Q":
					$letter=\'4\';
					break;
				case "R":
					$letter=\'4\';
					break;
				case "S":
					$letter=\'4\';
					break;
				case "T":
					$letter=\'4\';
					break;
				case "U":
					$letter=\'4\';
					break;
				case "V":
					$letter=\'5\';
					break;
				case "W":
					$letter=\'5\';
					break;
				case "X":
					$letter=\'5\';
					break;
				case "Y":
					$letter=\'5\';
					break;
				case "Z":
					$letter=\'5\';
					break;
			}
			
			eval("\$userbit = \"".$templates->get("listen_avatare_userbit")."\";");
			
            if(strtolower($gender[0])==strtolower($female[0])) $stringname="female".$letter;
            else if(strtolower($gender[0])==strtolower($male[0])) $stringname="male".$letter;
			
            $$stringname .= $userbit;
    }
	
	eval("\$page = \"".$templates->get("listen_avatare")."\";");
	echo $page;
}

/*Besonderheiten*/
if($mybb->input[\'action\']=="besonderheiten")
{
	$title=$lang->hp_listen_title_besonderheiten;
	
	$stop=$lang->hp_listen_besonder_stop;
		
	$result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid5 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid5 IS NOT NULL
	AND f.fid5 <> \'\'
	ORDER BY u.username ASC"
	);
	while($row=$db->fetch_array($result))
	{
		$userid = $row[\'uid\'];
		
		$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username = $usernamelink;
		
		$gruppen=explode(\'<br />\',nl2br($row[\'fid5\']));
		foreach($gruppen as $gruppe)
		{
			$gruppe = trim($gruppe);
		
			eval("\$userbit = \"".$templates->get("listen_besonderheiten_bit")."\";");
		
			$$gruppe.=$userbit;
		}
	}
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=5"
	);
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		$u=0;
		$i=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_besonderheiten_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_besonderheiten_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_besonderheiten_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
					}
					
					$userbit=$$gruppe;
					eval("\$namebit .= \"".$templates->get("listen_besonderheiten_namebit")."\";");
				}
			}
		}
		eval("\$tablebit .= \"".$templates->get("listen_besonderheiten_tablebit")."\";");
	}
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*Beziehungsliste*/
if($mybb->input[\'action\']=="beziehungsliste")
{
	$title=$lang->hp_listen_title_beziehungsliste;

	$result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid8, f.fid9 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid8 IS NOT NULL
	AND f.fid8 <> \'\'
	ORDER BY u.username ASC"
	);
	while($row=$db->fetch_array($result))
	{
		$userid = $row[\'uid\'];		
		$gruppe = trim($row[\'fid8\']);
		
		$partner = $row[\'fid9\'];
		
		$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username = $usernamelink;
		
		eval("\$userbit = \"".$templates->get("listen_beziehungsliste_bit")."\";");
		
		$$gruppe.=$userbit;
	}
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=8"
	);
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		$u=0;
		$i=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_beziehungsliste_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_beziehungsliste_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_beziehungsliste_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
					}
					
					$userbit=$$gruppe;
					eval("\$namebit .= \"".$templates->get("listen_beziehungsliste_namebit")."\";");
				}
			}
		}
		eval("\$tablebit .= \"".$templates->get("listen_beziehungsliste_tablebit")."\";");
	}
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*Blutstatus*/
if($mybb->input[\'action\']=="blutstatus")
{
	$title=$lang->hp_listen_title_blutstatus;

	$result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid10 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid10 IS NOT NULL
	AND f.fid10 <> \'\'
	ORDER BY u.username ASC"
	);
	while($row=$db->fetch_array($result))
	{
		$userid = $row[\'uid\'];		
		$gruppe = trim($row[\'fid10\']);
		
		$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username = $usernamelink;
		
		eval("\$userbit = \"".$templates->get("listen_blutstatus_namen_bit")."\";");
		
		$$gruppe.=$userbit;
	}
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=10"
	);
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		$u=0;
		$i=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_blutstatus_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_blutstatus_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_blutstatus_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
					}
					
					$userbit=$$gruppe;
					eval("\$namebit .= \"".$templates->get("listen_blutstatus_namebit")."\";");
				}
			}
		}
		eval("\$tablebit .= \"".$templates->get("listen_blutstatus_tablebit")."\";");
	}
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*Charakterbersicht*/
if($mybb->input[\'action\']=="charaktere")
{
	$title=$lang->hp_listen_title_charaktere;

    $result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid7, f.fid13 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid7 IS NOT NULL
	AND f.fid7 <> \'\'
	ORDER BY u.username ASC"
	);
	while($row=$db->fetch_array($result))
	{
		$userid = $row[\'uid\'];
		
		$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username = $usernamelink;
		
		if($row[\'fid13\']) $gruppen = explode(\'<br />\',nl2br($row[\'fid13\']));
		else $gruppen=explode(\'<br />\',nl2br($row[\'fid7\']));
		
		foreach($gruppen as $gruppe)
		{
			$gruppe = trim($gruppe);
		
			eval("\$userbit = \"".$templates->get("listen_charakter_namen_bit")."\";");
		
			$$gruppe.=$userbit;
		}
	}
	
	$i=0;
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=13"
	);
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		$u=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_charakter_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_charakter_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_charakter_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
						$i++;
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
						$i++;
					}
					
					$userbit=$$gruppe;
					eval("\$namebit .= \"".$templates->get("listen_charakter_namebit")."\";");
				}
			}
		}
	}
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=7"
	);
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		$u=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_charakter_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_charakter_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_charakter_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
					}
					
					$userbit=$$gruppe;
					eval("\$namebit .= \"".$templates->get("listen_charakter_namebit")."\";");
				}
			}
		}
		eval("\$tablebit .= \"".$templates->get("listen_charakter_tablebit")."\";");
	}
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*Namensliste*/
if($mybb->input[\'action\']=="namen")
{
	$title=$lang->hp_listen_title_namen;
	
	$male=$lang->hp_listen_male;
	$female=$lang->hp_listen_female;
	$fluid=$lang->hp_listen_fluid;
	
	$vor=$lang->hp_listen_vor;
	$nach=$lang->hp_listen_nach;
	
    $result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid1, f.fid25, f.fid26 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid1 IS NOT NULL
	AND f.fid1 <> \'\'
	AND f.fid25 IS NOT NULL
	AND f.fid25 <> \'\'
	AND f.fid26 IS NOT NULL
	AND f.fid26 <> \'\'"
	);


	while($row=$db->fetch_array($result))
	{
		$vornamen=$row[\'fid25\'];
		$lastname=$row[\'fid26\'];
	
		$array = explode(" ", $vornamen);
	
		
		if(strtolower($row[\'fid1\'][0])==strtolower($female[0])) $letter="w";
		else if(strtolower($row[\'fid1\'][0])==strtolower($male[0])) $letter="m";
		else if(strtolower($row[\'fid1\'][0])==strtolower($fluid[0])) $letter="f";
	
		$firststr.=$array[0].\',\'.$row[\'uid\'].\',\'.$row[\'usergroup\'].\',\'.$row[\'displaygroup\'].\',\'.$letter.";";
		$last.=$lastname.";";
	}
	
	$first=explode(\';\', $firststr);
	$names=explode(\';\', $last);
	
	$names = array_unique($names);
	asort($names);
	$controll=array();
	
	foreach($names as $username)
	{
		eval("\$nachname .= \"".$templates->get("listen_namen_bit")."\";");
	}
	
	asort($first);
	foreach($first as $value)
	{
		$userinfos=explode(\',\',$value);
	
		$firstname=$userinfos[0];
		$userid=$userinfos[1];
		$usergroup=$userinfos[2];
		$displaygroup=$userinfos[3];
		$gender=$userinfos[4];
	
		$test=$firstname{0};
		switch ($test)
		{
			case "A":
					$letter=\'1\';
					break;
			case "B":
					$letter=\'1\';
					break;
			case "C":
					$letter=\'1\';
					break;
			case "D":
					$letter=\'1\';
					break;
			case "E":
					$letter=\'1\';
					break;
			case "F":
					$letter=\'1\';
					break;
			case "G":
					$letter=\'2\';
					break;
			case "H":
					$letter=\'2\';
					break;
			case "I":
					$letter=\'2\';
					break;
			case "J":
					$letter=\'2\';
					break;
			case "K":
					$letter=\'2\';
					break;
			case "L":
					$letter=\'3\';
					break;
			case "M":
					$letter=\'3\';
					break;
			case "N":
					$letter=\'3\';
					break;
			case "O":
					$letter=\'3\';
					break;
			case "P":
					$letter=\'3\';
					break;
			case "Q":
					$letter=\'4\';
					break;
			case "R":
					$letter=\'4\';
					break;
			case "S":
					$letter=\'4\';
					break;
			case "T":
					$letter=\'4\';
					break;
			case "U":
					$letter=\'4\';
					break;
			case "V":
					$letter=\'5\';
					break;
			case "W":
					$letter=\'5\';
					break;
			case "X":
					$letter=\'5\';
					break;
			case "Y":
					$letter=\'5\';
					break;
			case "Z":
					$letter=\'5\';
					break;
		}
		if($gender=="w") $stringname="vweiblich".$letter;
		else if($gender=="m") $stringname="nmannlich".$letter;
		$usernamecolor = format_name($firstname, $usergroup, $displaygroup);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username=$usernamelink;
	
		if($userid>0) eval("\$namebit = \"".$templates->get("listen_namen_bit")."\";");
		
		if($gender=="f")
		{			
			$stringname="nmannlich".$letter;
			$$stringname .= $namebit;
			
			$stringname="vweiblich".$letter;
		}
		
		$$stringname .= $namebit;
	}

	eval("\$page = \"".$templates->get("listen_namen")."\";");
	echo $page;
}

/*Patroni*/
if($mybb->input[\'action\']=="patronus")
{
	$title=$lang->hp_listen_title_patronus;
	
    $result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid7, f.fid6, fid13 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid6 IS NOT NULL
	AND f.fid6 <> \'\'
	ORDER BY u.username ASC"
	);
	while($row=$db->fetch_array($result))
	{
		$userid = $row[\'uid\'];
		$patronus = $row[\'fid6\'];
		
		$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username = $usernamelink;
		
		if($row[\'fid13\']) $gruppen = explode(\'<br />\',nl2br($row[\'fid13\']));
		else $gruppen=explode(\'<br />\',nl2br($row[\'fid7\']));
		
		foreach($gruppen as $gruppe)
		{
			$gruppe = trim($gruppe);
		
			eval("\$userbit = \"".$templates->get("listen_patronus_bit")."\";");
		
			$$gruppe.=$userbit;
		}
	}
	
	$i=0;
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=13"
	);
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		$u=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_patronus_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_patronus_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_patronus_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
						$i++;
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
						$i++;
					}
					
					$userbit=$$gruppe;
					eval("\$namebit .= \"".$templates->get("listen_patronus_namebit")."\";");
				}
			}
		}
	}
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=7"
	);
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		$u=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_patronus_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_patronus_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_patronus_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
					}
					
					$userbit=$$gruppe;
					eval("\$namebit .= \"".$templates->get("listen_patronus_namebit")."\";");
				}
			}
		}
		eval("\$tablebit .= \"".$templates->get("listen_patronus_tablebit")."\";");
	}
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*Reinblutliste*/
if($mybb->input[\'action\']=="reinblut")
{
	$title=$lang->hp_listen_title_reinblut;
	
	$info=$lang->hp_listen_reinblut_info;
	$stop=$lang->hp_listen_reinblut_stop;
	
	$result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid11 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid11 IS NOT NULL
		AND f.fid11 <> \'\'
	ORDER BY u.username ASC"
	);

	while($row=$db->fetch_array($result))
	{
			$userid = $row[\'uid\'];
			
			$besonderheiten = nl2br($row[\'fid11\']);
			$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
			$usernamelink = build_profile_link($usernamecolor, $userid);
	
			$username = $usernamelink;
	
			$gruppen=explode(\'<br />\',$besonderheiten);
	
			foreach($gruppen as $gruppe)
			{
					$test=trim($gruppe);
					eval("\$userbit = \"".$templates->get("listen_reinblut_namen_bit")."\";");
					$$test.=$userbit;
			}
	}
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=11"
	);
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		$u=0;
		$i=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_reinblut_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_reinblut_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_reinblut_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
					}
					
					$userbit=$$gruppe;
					eval("\$namebit .= \"".$templates->get("listen_reinblut_namebit")."\";");
				}
			}
		}
		
		eval("\$tablebit .= \"".$templates->get("listen_reinblut_tablebit")."\";");
		
	}

	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*Gesinnungen*/
if($mybb->input[\'action\']=="gesinnung")
{
	$title=$lang->hp_listen_title_gesinnung;
	
	$result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid3 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid3 IS NOT NULL
	AND f.fid3 <> \'\'
	ORDER BY u.username ASC"
	);
	while($row=$db->fetch_array($result))
	{
		$userid = $row[\'uid\'];		
		$gruppe = trim($row[\'fid3\']);
		
		$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username = $usernamelink;
		
		eval("\$userbit = \"".$templates->get("listen_gesinnung_namen_bit")."\";");
		
		$$gruppe.=$userbit;
	}
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=3"
	);
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		$u=0;
		$i=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_gesinnung_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_gesinnung_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_gesinnung_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
					}
					
					$userbit=$$gruppe;
					eval("\$namebit .= \"".$templates->get("listen_gesinnung_namebit")."\";");
				}
			}
		}
		eval("\$tablebit .= \"".$templates->get("listen_gesinnung_tablebit")."\";");
	}
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*Berufe*/
if($mybb->input[\'action\']=="berufe")
{
	$title=$lang->hp_listen_title_berufe;
	
	$result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid12, f.fid7 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid12 IS NOT NULL
	AND f.fid12 <> \'\'
	ORDER BY u.username ASC"
	);
	while($row=$db->fetch_array($result))
	{
		$userid = $row[\'uid\'];		
		$gruppe = trim($row[\'fid7\']);
		
		$beruf = trim($row[\'fid12\']);
		
		$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username = $usernamelink;
		
		$gruppen=explode(\'<br />\',nl2br($row[\'fid7\']));
		foreach($gruppen as $gruppe)
		{
			$gruppe = trim($gruppe);
		
			eval("\$userbit = \"".$templates->get("listen_berufe_bit")."\";");
		
			$$gruppe.=$userbit;
		}
	}
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=7"
	);
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		$u=0;
		$i=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_berufe_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_berufe_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_berufe_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
					}
					
					$userbit=$$gruppe;
					eval("\$namebit .= \"".$templates->get("listen_berufe_namebit")."\";");
				}
			}
		}
		eval("\$tablebit .= \"".$templates->get("listen_berufe_tablebit")."\";");
	}
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*Schulband*/
if($mybb->input[\'action\']=="band")
{
	$title=$lang->hp_listen_title_band;
	
	$result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid19 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid19 IS NOT NULL
	AND f.fid19 <> \'\'
	ORDER BY u.username ASC"
	);
	while($row=$db->fetch_array($result))
	{
		$userid = $row[\'uid\'];	
		
		$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username = $usernamelink;
		
		$gruppen=explode(\'<br />\',nl2br($row[\'fid19\']));
		foreach($gruppen as $gruppe)
		{
			$gruppe = trim($gruppe);
		
			eval("\$userbit = \"".$templates->get("listen_band_namen_bit")."\";");
		
			$$gruppe.=$userbit;
		}
	}
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=19"
	);
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		$u=0;
		$i=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_band_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_band_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_band_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
					}
					
					$userbit=$$gruppe;
					eval("\$namebit .= \"".$templates->get("listen_band_namebit")."\";");
				}
			}
		}
		eval("\$tablebit .= \"".$templates->get("listen_band_tablebit")."\";");
	}
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*Schulzeitung*/
if($mybb->input[\'action\']=="zeitung")
{
	$title=$lang->hp_listen_title_zeitung;
	
	$result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid20 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid20 IS NOT NULL
	AND f.fid20 <> \'\'
	ORDER BY u.username ASC"
	);
	while($row=$db->fetch_array($result))
	{
		$userid = $row[\'uid\'];	
		
		$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username = $usernamelink;
		
		$gruppen=explode(\'<br />\',nl2br($row[\'fid20\']));
		foreach($gruppen as $gruppe)
		{
			$gruppe = trim($gruppe);
		
			eval("\$userbit = \"".$templates->get("listen_zeitung_namen_bit")."\";");
		
			$$gruppe.=$userbit;
		}
	}
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=20"
	);
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		$u=0;
		$i=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_zeitung_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_zeitung_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_zeitung_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
					}
					
					$userbit=$$gruppe;
					eval("\$namebit .= \"".$templates->get("listen_zeitung_namebit")."\";");
				}
			}
		}
		eval("\$tablebit .= \"".$templates->get("listen_zeitung_tablebit")."\";");
	}
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*AG\'s & Club\'s*/
if($mybb->input[\'action\']=="clubs")
{
	$title=$lang->hp_listen_title_clubs;
	
	$result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid17 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid17 IS NOT NULL
	AND f.fid17 <> \'\'
	ORDER BY u.username ASC"
	);
	while($row=$db->fetch_array($result))
	{
		$userid = $row[\'uid\'];	
		
		$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username = $usernamelink;
		
		$gruppen=explode(\'<br />\',nl2br($row[\'fid17\']));
		foreach($gruppen as $gruppe)
		{
			$gruppe = trim($gruppe);
		
			eval("\$userbit = \"".$templates->get("listen_ags_namen_bit")."\";");
		
			$$gruppe.=$userbit;
		}
	}
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=17"
	);
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		$u=0;
		$i=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_ags_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_ags_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_ags_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
					}
					
					$userbit=$$gruppe;
					eval("\$namebit .= \"".$templates->get("listen_ags_namebit")."\";");
				}
			}
		}
		eval("\$tablebit .= \"".$templates->get("listen_ags_tablebit")."\";");
	}
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*Quidditch*/
if($mybb->input[\'action\']=="quidditch")
{
	$title=$lang->hp_listen_title_quidditch;
	
	$result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid13, fid18, fid16 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid18 IS NOT NULL
	AND f.fid18 <> \'\'
	ORDER BY u.username ASC"
	);
	while($row=$db->fetch_array($result))
	{
		$userid = $row[\'uid\'];		
		$haus = trim($row[\'fid13\']);
		
		$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username = $usernamelink;
		
		$gruppen=explode(\'<br />\',nl2br($row[\'fid18\']));
		foreach($gruppen as $gruppe)
		{
			$gruppe = $haus."_".trim($gruppe);
		
			eval("\$userbit = \"".$templates->get("listen_quidditch_namen_bit")."\";");
		
			$$gruppe.=$userbit;
		}
		
		$gruppen=explode(\'<br />\',nl2br($row[\'fid16\']));
		foreach($gruppen as $gruppe)
		{
			if($gruppe==$lang->hp_listen_cap)
			{
				$gruppe = $haus."_".trim($gruppe);
				
				eval("\$userbit = \"".$templates->get("listen_quidditch_namen_bit")."\";");
		
				$$gruppe.=$userbit;
			}
		}
	}
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=13"
	);
	
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/2);
		$rest=$counting-$zeilen*2;
		
		$u=0;
		$i=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			$div="";
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				
				$qresult=$db->query("
				SELECT fid,type FROM ".TABLE_PREFIX."profilefields
				WHERE fid=18"
				);
				while($qrow=$db->fetch_array($qresult))
				{
					$hauser=explode(\'<br />\',nl2br($qrow[\'type\']));
					$x=0;
					
					$counter=count($hauser);
					$hauser[$counter]=$lang->hp_listen_cap;
					
					foreach($hauser as $haus)
					{
						if($haus!="select" && $haus!="multiselect")
						{
							$hgruppe=$gruppe."_".trim($haus);
							$userbit=$$hgruppe;
							
							if($x==0)
							{
								eval("\$a = \"".$templates->get("listen_quidditch_div_bit")."\";");
								$x=1;
							}
							else
							{
								eval("\$b = \"".$templates->get("listen_quidditch_div_bit")."\";");
								eval("\$div .= \"".$templates->get("listen_quidditch_div")."\";");
								$x=0;
							}
						}
					}
					
					if($x==1)
					{
						$b="";
						eval("\$div .= \"".$templates->get("listen_quidditch_div")."\";");
					}
				}
				
				$userbit=$div;
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						eval("\$namebit .= \"".$templates->get("listen_quidditch_namebit")."\";");
						$i++;
					}
					else
					{
						eval("\$namebit .= \"".$templates->get("listen_quidditch_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_quidditch_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
					}
					
					eval("\$namebit .= \"".$templates->get("listen_quidditch_namebit")."\";");
				}
			}
		}
		eval("\$tablebit .= \"".$templates->get("listen_quidditch_tablebit")."\";");
	}
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*Kursliste*/
if($mybb->input[\'action\']=="kursliste")
{
	$title=$lang->hp_listen_title_kursliste;
	
	$result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid15 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid15 IS NOT NULL
	AND f.fid15 <> \'\'
	ORDER BY u.username ASC"
	);
	while($row=$db->fetch_array($result))
	{
		$userid = $row[\'uid\'];	
		
		$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username = $usernamelink;
		
		$gruppen=explode(\'<br />\',nl2br($row[\'fid15\']));
		foreach($gruppen as $gruppe)
		{
			$gruppe = trim($gruppe);
		
			eval("\$userbit = \"".$templates->get("listen_kurs_namen_bit")."\";");
			$$gruppe.=$userbit;
		}
	}
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=15"
	);
	while($row=$db->fetch_array($result))
	{
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		$u=0;
		$i=0;
		foreach($gruppen as $gruppe)
		{
			$gruppe=trim($gruppe);
			if($gruppe!="select" && $gruppe!="multiselect")
			{
				$userbit="";
				if($u<$zeilen)
				{
					$weite="30%";
					$colls="";
					if($i<2)
					{
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_kurs_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$gruppe;
						eval("\$namebit .= \"".$templates->get("listen_kurs_namebit")."\";");
						eval("\$tablebit .= \"".$templates->get("listen_kurs_tablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				else
				{
					if($rest==1)
					{
						$weite="100%";
						$colls="colspan=3";
					}
					else 
					{
						$weite="50%";
						$colls="colspan=2";
					}
					
					$userbit=$$gruppe;
					eval("\$namebit .= \"".$templates->get("listen_kurs_namebit")."\";");
				}
			}
		}
		eval("\$tablebit .= \"".$templates->get("listen_kurs_tablebit")."\";");
	}
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*Wer schlft wo*/
if($mybb->input[\'action\']=="classes")
{
	$title=$lang->hp_listen_title_classes;
	
	$male=$lang->hp_listen_male;
	$female=$lang->hp_listen_female;
	$fluid=$lang->hp_listen_fluid;
	
	$class=$lang->hp_listen_class;
		
	$result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid13, f.fid14, f.fid1 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid16 IS NOT NULL
	AND f.fid16 <> \'\'
	ORDER BY u.username ASC"
	);

	while($row=$db->fetch_array($result))
	{
		$userid = $row[\'uid\'];
		$haus=$row[\'fid13\'];
		$jahr=$row[\'fid14\'];
		$gender=$row[\'fid1\'];
		
		$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username = $usernamelink;
		
		if(strtolower($gender)==strtolower($fluid))
		{
			$letter=$haus.$female.$jahr;
			$letter=strtolower($letter);
		
			$gruppe=strtolower($letter);
			
			eval("\$userbit = \"".$templates->get("listen_wsw_namen_bit")."\";");
			$$letter=$userbit;
			
			$gender=$male;
		}
		
		$letter=$haus.$gender.$jahr;
		$letter=strtolower($letter);
		
		$gruppe=strtolower($letter);
		
		eval("\$userbit = \"".$templates->get("listen_wsw_namen_bit")."\";");
		$$letter=$userbit;
	}
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=13"
	);
	while($row=$db->fetch_array($result))
	{
		$hauser=explode(\'<br />\',nl2br($row[\'type\']));
		$x=0;
		foreach($hauser as $haus)
		{
			$haus=trim($haus);
			if($haus!="select" && $haus!="multiselect")
			{
				$malebit=$male;
				$femalebit=$female;
				$info=$haus;
				
				if($x==0)
				{
					eval("\$a .= \"".$templates->get("listen_wsw_classes_div")."\";");
					$i=0;
					while($i<7)
					{
						$i++;
						$mletter=$haus.$male.$i;
						$fletter=$haus.$female.$i;
						
						$mletter=strtolower($mletter);
						$fletter=strtolower($fletter);
						
						$malebit=$$mletter;
						$femalebit=$$fletter;
						
						if(!$malebit)
						{
							$username="-";
							eval("\$malebit = \"".$templates->get("listen_wsw_namen_bit")."\";");
						}
						if(!$femalebit)
						{
							$username="-";
							eval("\$femalebit = \"".$templates->get("listen_wsw_namen_bit")."\";");
						}
						
						$info=$class.$i;
						
						eval("\$a .= \"".$templates->get("listen_wsw_classes_divbit")."\";");
					}
					$x=1;
				}
				else
				{
					eval("\$b .= \"".$templates->get("listen_wsw_classes_div")."\";");
					$i=0;
					while($i<7)
					{
						$i++;
						$mletter=$haus.$male.$i;
						$fletter=$haus.$female.$i;
						
						$mletter=strtolower($mletter);
						$fletter=strtolower($fletter);
						
						$malebit=$$mletter;
						$femalebit=$$fletter;
						
						if(!$malebit)
						{
							$username="-";
							eval("\$malebit = \"".$templates->get("listen_wsw_namen_bit")."\";");
						}
						if(!$femalebit)
						{
							$username="-";
							eval("\$femalebit = \"".$templates->get("listen_wsw_namen_bit")."\";");
						}
						
						$info=$class.$i;
						
						eval("\$b .= \"".$templates->get("listen_wsw_classes_divbit")."\";");
					}
					$x=0;
				}
			}
		}
			eval("\$div .= \"".$templates->get("listen_wsw_div")."\";");
	}
	$userbit=$div;
	$gruppe="";
	eval("\$namebit = \"".$templates->get("listen_wsw_namebit")."\";");
	eval("\$tablebit = \"".$templates->get("listen_wsw_tablebit")."\";");
	
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*Schulpositionen*/
if($mybb->input[\'action\']=="positionen")
{
	$title=$lang->hp_listen_title_positionen;
	
	$vertr=$lang->hp_listen_vertr;
	$schul=$lang->hp_listen_schul;
	
	$gmale=$lang->hp_listen_male;
	$gfemale=$lang->hp_listen_female;
	$fluid=$lang->hp_listen_fluid;
		
	$result=$db->query("
	SELECT u.uid, u.username, u.usergroup, u.displaygroup, f.fid16, f.fid13, f.fid14, f.fid1 FROM ".TABLE_PREFIX."users u
	LEFT JOIN ".TABLE_PREFIX."userfields f
	ON u.uid = f.ufid
	WHERE f.fid16 IS NOT NULL
	AND f.fid16 <> \'\'
	ORDER BY u.username ASC"
	);

	while($row=$db->fetch_array($result))
	{
		$userid = $row[\'uid\'];
		$positionen=$row[\'fid16\'];
		$haus=$row[\'fid13\'];
		$jahr=$row[\'fid14\'];
		$gender=$row[\'fid1\'];
		
		
	
		$usernamecolor = format_name($row[\'username\'], $row[\'usergroup\'], $row[\'displaygroup\']);
		$usernamelink = build_profile_link($usernamecolor, $userid);
	
		$username = $usernamelink;
	
		$position=explode(\'<br />\',$positionen);
	
		foreach($position as $positionen)
		{
				$pos=trim($positionen);
				switch ($pos)
				{
						case $vertr:
								$letter=$vertr.$haus.$jahr;
								$letter=strtolower($letter);
								
								$iletter="int".$vertr.$haus.$jahr;
								$iletter=strtolower($iletter);
								
								$i=$$iletter;
								$i++;
								$$iletter=$i;
								
								$info=$gender;
								$username=$username." (".$info.")";
								
								eval("\$userbit = \"".$templates->get("listen_schulpos_namen_bit")."\";");
								
								$$letter.=$userbit;
								break;
						case $schul:
								$info=$haus;
								$username=$username." (".$info.")";
								
								if(strtolower($gender)==strtolower($gmale)) eval("\$male = \"".$templates->get("listen_schulpos_namen_bit")."\";");
								if(strtolower($gender)==strtolower($gfemale) || strtolower($gender)==strtolower($fluid)) eval("\$female = \"".$templates->get("listen_schulpos_namen_bit")."\";");
								break;
				}
		}
	}
	
	$haus=$schul;
	
	if(!$male)$male="-";
	if(!$female)$female="-";
	
	$male=$gmale."<br>".$male;
	$female=$gfemale."<br>".$female;
	
	eval("\$div = \"".$templates->get("listen_schulpos_classes_div")."\";");
	
	$haus=$vertr;
	$male="";
	$female="";
	
	eval("\$div .= \"".$templates->get("listen_schulpos_classes_div")."\";");
	
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=13"
	);
	while($row=$db->fetch_array($result))
	{
		$hauser=explode(\'<br />\',nl2br($row[\'type\']));
		$x=0;
		
		foreach($hauser as $haus)
		{
			if($haus!="select" && $haus!="multiselect")
			{
				if($x==0)
				{
					$hgruppe=trim($vertr).trim($haus)."5";
					$hgruppe=strtolower($hgruppe);
					
					$iletter="int".trim($vertr).trim($haus)."5";
					$iletter=strtolower($iletter);
					$i=$$iletter;
					
					if($i<1)
					{
						$username="-";
						eval("\$userbit = \"".$templates->get("listen_schulpos_namen_bit")."\";");
						
						$$hgruppe=$userbit.$userbit;
					}
					else if($i<2)
					{
						$username="-";
						eval("\$userbit = \"".$templates->get("listen_schulpos_namen_bit")."\";");
						
						$$hgruppe.=$userbit;
					}
					
					$hhaus=$haus;
					$haus="5";
					$userbit=$$hgruppe;
					eval("\$a5 = \"".$templates->get("listen_schulpos_div_bit")."\";");
					
					$haus=$hhaus;
					
					$hgruppe=trim($vertr).trim($haus)."6";
					$hgruppe=strtolower($hgruppe);
					
					$iletter="int".trim($vertr).trim($haus)."6";
					$iletter=strtolower($iletter);
					$i=$$iletter;
					
					if($i<1)
					{
						$username="-";
						eval("\$userbit = \"".$templates->get("listen_schulpos_namen_bit")."\";");
						
						$$hgruppe=$userbit.$userbit;
					}
					else if($i<2)
					{
						$username="-";
						eval("\$userbit = \"".$templates->get("listen_schulpos_namen_bit")."\";");
						
						$$hgruppe.=$userbit;
					}
					
					$hhaus=$haus;
					$haus="6";
					$userbit=$$hgruppe;
					eval("\$a6 = \"".$templates->get("listen_schulpos_div_bit")."\";");
					
					$userbit=$a5.$a6;
					$haus=$hhaus;
					
					eval("\$a = \"".$templates->get("listen_schulpos_div_bit")."\";");
					$x=1;
				}
				else
				{
					$hgruppe=trim($vertr).trim($haus)."5";
					$hgruppe=strtolower($hgruppe);
					
					$iletter="int".trim($vertr).trim($haus)."5";
					$iletter=strtolower($iletter);
					$i=$$iletter;
					
					if($i<1)
					{
						$username="-";
						eval("\$userbit = \"".$templates->get("listen_schulpos_namen_bit")."\";");
						
						$$hgruppe=$userbit.$userbit;
					}
					else if($i<2)
					{
						$username="-";
						eval("\$userbit = \"".$templates->get("listen_schulpos_namen_bit")."\";");
						
						$$hgruppe.=$userbit;
					}
					
					$hhaus=$haus;
					$haus="5";
					$userbit=$$hgruppe;
					eval("\$b5 = \"".$templates->get("listen_schulpos_div_bit")."\";");
					
					$haus=$hhaus;
					
					$hgruppe=trim($vertr).trim($haus)."6";
					$hgruppe=strtolower($hgruppe);
					
					$iletter="int".trim($vertr).trim($haus)."6";
					$iletter=strtolower($iletter);
					$i=$$iletter;
					
					if($i<1)
					{
						$username="-";
						eval("\$userbit = \"".$templates->get("listen_schulpos_namen_bit")."\";");
						
						$$hgruppe=$userbit.$userbit;
					}
					else if($i<2)
					{
						$username="-";
						eval("\$userbit = \"".$templates->get("listen_schulpos_namen_bit")."\";");
						
						$$hgruppe.=$userbit;
					}
					
					$hhaus=$haus;
					$haus="6";
					$userbit=$$hgruppe;
					eval("\$b6 = \"".$templates->get("listen_schulpos_div_bit")."\";");
					
					$userbit=$b5.$b6;
					$haus=$hhaus;
					
					eval("\$b = \"".$templates->get("listen_schulpos_div_bit")."\";");
					eval("\$div .= \"".$templates->get("listen_schulpos_div")."\";");
					$x=0;
				}
			}
		}
		if($x==1)
		{
			$b="";
			eval("\$div .= \"".$templates->get("listen_schulpos_div")."\";");
		}
	}
	
	
	$userbit=$div;
	$gruppe="";
	eval("\$namebit = \"".$templates->get("listen_schulpos_namebit")."\";");
	eval("\$tablebit = \"".$templates->get("listen_schulpos_tablebit")."\";");
	
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

/*Seriencharaktere*/
if($mybb->input[\'action\']=="seriencharas")
{
	$title=$lang->hp_listen_title_seriencharas;
	
	$result=$db->query("
	SELECT * FROM ".TABLE_PREFIX."seriencharas
	ORDER BY username ASC"
	);
	while($row=$db->fetch_array($result))
	{
		
		$name=$row[\'name\'];
		$username=$row[\'username\'];
		$age=$row[\'age\'];
		$gender=$row[\'gender\'];
		$gruppe=str_replace(\' \',\'_\',$row[\'gruppe\']);
		
		$gruppe=$gruppe."_".$gender;
		
		eval("\$userbit = \"".$templates->get("listen_seriencharas_userbit")."\";");
		
		
		$query = $db->simple_select("users", "uid, usergroup, displaygroup", "username=\'{$username}\'");
		$seriencharas = $db->fetch_array($query);
		
		if($seriencharas[\'uid\']>0)
		{
			$usernamecolor = format_name($userbit, $seriencharas[\'usergroup\'], $seriencharas[\'displaygroup\']);
			$usernamelink = build_profile_link($usernamecolor, $seriencharas[\'uid\']);
			$username = $usernamelink;
		}
		else $username=$userbit;
		
		eval("\$userbit = \"".$templates->get("listen_seriencharas_namen_bit")."\";");
		
		$$gruppe.=$userbit;
	}
	
	$i=0;
	$result=$db->query("
	SELECT fid,type FROM ".TABLE_PREFIX."profilefields
	WHERE fid=13"
	);while($row=$db->fetch_array($result))
	{
		$gquery = $db->simple_select("profilefields", "*", "fid=7");
		$grow=$db->fetch_array($gquery);
		
		$row[\'type\'].=\'
		\'.$grow[\'type\'];
		
		$gruppen=explode(\'<br />\',nl2br($row[\'type\']));
		$counting=count($gruppen)-1;
		$zeilen=floor($counting/3);
		$rest=$counting-$zeilen*3;
		
		foreach($gruppen as $group)
		{
			if(trim($group)!="select" && trim($group)!="multiselect")
			{
				$i=0;
				$namebit="";
				$subtablebit="";
				$gruppe="";
				$groupname="";
				
				$genders[0]="female";
				$genders[1]="male";
				
				foreach($genders as $gender)
				{
					$group=str_replace(\' \',\'_\',trim($group));
					$gruppe=$gender;
					$groupname=$group."_".$gruppe;
					
					$group=str_replace(\'_\',\' \',trim($group));
					
					$userbit="";
					
					$weite="50%";
					$colls="";
					if($i<1)
					{
						$userbit=$$groupname;
						eval("\$namebit .= \"".$templates->get("listen_seriencharas_namebit")."\";");
						$i++;
					}
					else
					{
						
						$userbit=$$groupname;
						eval("\$namebit .= \"".$templates->get("listen_seriencharas_namebit")."\";");
						eval("\$subtablebit .= \"".$templates->get("listen_seriencharas_subtablebit")."\";");
						$u++;
						$i=0;
						
						$namebit="";
					}
				}
				if($i>0) eval("\$subtablebit .= \"".$templates->get("listen_seriencharas_subtablebit")."\";");
				
				eval("\$tablebit .= \"".$templates->get("listen_seriencharas_tablebit")."\";");
			}
		}
	}
	
	eval("\$page = \"".$templates->get("listen_pagebit")."\";");
	echo $page;
}

?>';

	$phpname[1]='../inc/languages/deutsch_du/hp_listen.lang.php';
	$phpinhalt[1]='<?php

$l[\'hp_listen_listenname\'] = \'Listen\';

$l[\'hp_listen_male\'] = \'Mnnlich\';
$l[\'hp_listen_female\'] = \'Weiblich\';
$l[\'hp_listen_fluid\'] = \'Fluid\';

$l[\'hp_listen_title_main\'] = \'Allgemeine Listen\';
$l[\'hp_listen_title_student\'] = \'Schulinterne Listen\';
$l[\'hp_listen_title_avatare\'] = \'Avatarpersonen\';
$l[\'hp_listen_title_besonderheiten\'] = \'Vergebene Besonderheiten\';
$l[\'hp_listen_title_beziehungsliste\'] = \'Beziehungsliste\';
$l[\'hp_listen_title_blutstatus\'] = \'Blutstatus\';
$l[\'hp_listen_title_charaktere\'] = \'Charakterbersicht\';
$l[\'hp_listen_title_namen\'] = \'Vergebene Namen\';
$l[\'hp_listen_title_patronus\'] = \'Patronusliste\';
$l[\'hp_listen_title_reinblut\'] = \'Reinblutfamilien\';
$l[\'hp_listen_title_gesinnung\'] = \'Gesinnungen\';
$l[\'hp_listen_title_berufe\'] = \'Liste der Berufe\';
$l[\'hp_listen_title_zweitcharas\'] = \'Mehrfach-Charaktere\';
$l[\'hp_listen_title_claes\'] = \'Wer schlft Wo?\';
$l[\'hp_listen_title_kursliste\'] = \'Kursliste\';
$l[\'hp_listen_title_quidditch\'] = \'Quidditchmannschaften\';
$l[\'hp_listen_title_clubs\'] = \'AG\\\'s & Club\\\'s\';
$l[\'hp_listen_title_zeitung\'] = \'Schlerzeitung\';
$l[\'hp_listen_title_band\'] = \'Schulband\';
$l[\'hp_listen_title_positionen\'] = \'Schlerpositionen\';
$l[\'hp_listen_title_seriencharas\'] = \'Buchcharaktere\';

$l[\'hp_listen_besonder_stop\']=\'<br><b>Aufnahmestopp:</b> Metamorphagi, Legilimentik, Werwlfe und unregistrierte Animagi men generell abgesprochen werden.\';

$l[\'hp_listen_vor\'] = \'Vornamen\';
$l[\'hp_listen_nach\'] = \'Nachnamen\';

$l[\'hp_listen_vertr\'] = \'Vertrauensschler\';
$l[\'hp_listen_schul\'] = \'Schulsprecher\';
$l[\'hp_listen_cap\'] = \'Quidditchkapitn\';

$l[\'hp_listen_reinblut_info\'] = \'<br>Jeder Charakter, der Reinbltig ist oder in einem Verwandtschaftsgrad bis zu den Groeltern steht, wird hier angezeigt. <b>Neue User</b> haben hier eine bersicht ber die freien Familien. Wollt ihr euren Charakter einer Familie hinzufgen, die bereits Mitglieder hat, so seht ihr hier mit welchen Usern ihr euch absprechen mt.<b>\';
$l[\'hp_listen_reinblut_stop\'] = \'<br><b>AUFNAHMESTOPP (Aunahme: Buchcharaktere & Gesuche) :</b> Derzeit keine\';

$l[\'hp_listen_cla\'] = \'Klasse: \';';

	$phpname[2]='../inc/languages/deutsch_sie/hp_listen.lang.php';
	$phpinhalt[2]='<?php

$l[\'hp_listen_listenname\'] = \'Listen\';

$l[\'hp_listen_male\'] = \'Mnnlich\';
$l[\'hp_listen_female\'] = \'Weiblich\';
$l[\'hp_listen_fluid\'] = \'Fluid\';

$l[\'hp_listen_title_main\'] = \'Allgemeine Listen\';
$l[\'hp_listen_title_student\'] = \'Schulinterne Listen\';
$l[\'hp_listen_title_avatare\'] = \'Avatarpersonen\';
$l[\'hp_listen_title_besonderheiten\'] = \'Vergebene Besonderheiten\';
$l[\'hp_listen_title_beziehungsliste\'] = \'Beziehungsliste\';
$l[\'hp_listen_title_blutstatus\'] = \'Blutstatus\';
$l[\'hp_listen_title_charaktere\'] = \'Charakterbersicht\';
$l[\'hp_listen_title_namen\'] = \'Vergebene Namen\';
$l[\'hp_listen_title_patronus\'] = \'Patronusliste\';
$l[\'hp_listen_title_reinblut\'] = \'Reinblutfamilien\';
$l[\'hp_listen_title_gesinnung\'] = \'Gesinnungen\';
$l[\'hp_listen_title_berufe\'] = \'Liste der Berufe\';
$l[\'hp_listen_title_zweitcharas\'] = \'Mehrfach-Charaktere\';
$l[\'hp_listen_title_claes\'] = \'Wer schlft Wo?\';
$l[\'hp_listen_title_kursliste\'] = \'Kursliste\';
$l[\'hp_listen_title_quidditch\'] = \'Quidditchmannschaften\';
$l[\'hp_listen_title_clubs\'] = \'AG\\\'s & Club\\\'s\';
$l[\'hp_listen_title_zeitung\'] = \'Schlerzeitung\';
$l[\'hp_listen_title_band\'] = \'Schulband\';
$l[\'hp_listen_title_positionen\'] = \'Schlerpositionen\';
$l[\'hp_listen_title_seriencharas\'] = \'Buchcharaktere\';

$l[\'hp_listen_besonder_stop\']=\'<br><b>Aufnahmestopp:</b> Metamorphagi, Legilimentik, Werwlfe und unregistrierte Animagi men generell abgesprochen werden.\';

$l[\'hp_listen_vor\'] = \'Vornamen\';
$l[\'hp_listen_nach\'] = \'Nachnamen\';

$l[\'hp_listen_vertr\'] = \'Vertrauensschler\';
$l[\'hp_listen_schul\'] = \'Schulsprecher\';
$l[\'hp_listen_cap\'] = \'Quidditchkapitn\';

$l[\'hp_listen_reinblut_info\'] = \'<br>Jeder Charakter, der Reinbltig ist oder in einem Verwandtschaftsgrad bis zu den Groeltern steht, wird hier angezeigt. <b>Neue User</b> haben hier eine bersicht ber die freien Familien. Wollt ihr euren Charakter einer Familie hinzufgen, die bereits Mitglieder hat, so seht ihr hier mit welchen Usern ihr euch absprechen mt.<b>\';
$l[\'hp_listen_reinblut_stop\'] = \'<br><b>AUFNAHMESTOPP (Aunahme: Buchcharaktere & Gesuche) :</b> Derzeit keine\';

$l[\'hp_listen_cla\'] = \'Klasse: \';';

	$phpname[3]='../inc/languages/english/hp_listen.lang.php';
	$phpinhalt[3]='<?php

$l[\'hp_listen_listenname\'] = \'Lists\';

$l[\'hp_listen_male\'] = \'Male\';
$l[\'hp_listen_female\'] = \'Female\';
$l[\'hp_listen_fluid\'] = \'Fluid\';

$l[\'hp_listen_title_main\'] = \'General lists\';
$l[\'hp_listen_title_student\'] = \'School internal lists\';
$l[\'hp_listen_title_avatare\'] = \'Avatars\';
$l[\'hp_listen_title_besonderheiten\'] = \'Special award\';
$l[\'hp_listen_title_beziehungsliste\'] = \'Relations list\';
$l[\'hp_listen_title_blutstatus\'] = \'Blood status\';
$l[\'hp_listen_title_charaktere\'] = \'Charakters\';
$l[\'hp_listen_title_namen\'] = \'Taken Names\';
$l[\'hp_listen_title_patronus\'] = \'Patronus lis\';
$l[\'hp_listen_title_reinblut\'] = \'Pureblood Familys\';
$l[\'hp_listen_title_gesinnung\'] = \'Sentiments\';
$l[\'hp_listen_title_berufe\'] = \'List of occupations\';
$l[\'hp_listen_title_zweitcharas\'] = \'Multiple Characters\';
$l[\'hp_listen_title_classes\'] = \'Who sleeps Where?\';
$l[\'hp_listen_title_kursliste\'] = \'Lessons list\';
$l[\'hp_listen_title_quidditch\'] = \'Quidditch\';
$l[\'hp_listen_title_clubs\'] = \'AG\\\'s & Club\\\'s\';
$l[\'hp_listen_title_zeitung\'] = \'School newspaper\';
$l[\'hp_listen_title_band\'] = \'School band\';
$l[\'hp_listen_title_positionen\'] = \'Student positions\';
$l[\'hp_listen_title_seriencharas\'] = \'Book-Characters\';

$l[\'hp_listen_besonder_stop\']=\'<br><b>Hiring freeze:</b> Metamorphagi, Legilimentik, Werewolves and unregistered Animagi must generally be discussed.\';

$l[\'hp_listen_vor\'] = \'First names\';
$l[\'hp_listen_nach\'] = \'Last names\';

$l[\'hp_listen_vertr\'] = \'Prefects\';
$l[\'hp_listen_schul\'] = \'Head Boy/Girl\';
$l[\'hp_listen_cap\'] = \'Quidditchcaptain\';

$l[\'hp_listen_reinblut_info\'] = \'<br>Any character who is Pureblood or in a relationship to the grandparents is displayed here. <b> New users </ b> have an overview of the free families here. If you want to add your character to a family that already has members, you can see here which users you have to contact.<b>\';
$l[\'hp_listen_reinblut_stop\'] = \'<br><b>RECORD STOP (Exception: Book Characters & Requests): </b> Currently nothing\';

$l[\'hp_listen_class\'] = \'Class: \';';

	$phpname[4]='../inc/languages/deutsch_du/admin/multifields_module_meta.lang.php';
	$phpinhalt[4]='<?php
// Language File (Deutsch) fr das MyBB Plugin HP-Listen
//  2018 Celine Geneau
// ---------------------------------------------------
// Last Update: 30.09.2018

$l[\'multifields\'] = "Multi-Listenfelder";

$l[\'multifields_settings\'] = "Multi-Listenfelder";
$l[\'avas\'] = "Multi-Avatare";
$l[\'spezials\'] = "Besondere Fhigkeiten";
$l[\'quidditch\'] = "Quidditchpositionen";
$l[\'can_multifields_dsgvo\'] = "Kann Multi-Listenfelder-Einstellungen vornehmen";';
	
	$phpname[5]='../inc/languages/deutsch_du/admin/multifields_settings.lang.php';
	$phpinhalt[5]='<?php
// Language File (Deutsch) fr das MyBB Plugin HP-Listen
//  2018 Celine Geneau
// ---------------------------------------------------
// Last Update: 30.09.2018

$l[\'multifields_ava_settings\'] = "Multi-Listenfelder";
$l[\'multifields_ava_settings_desc\'] = "Hier werden die Einstellungen fr die Listenfelder vorgenommen, welche mehrfach verfgbar sind.";

$l[\'avaname\'] = "Name des Avatars";
$l[\'avaanzahl\'] = "Typ/Anzahl";

$l[\'spezialname\'] = "Name der Fhigkeit";
$l[\'spezialanzahl\'] = "Typ/Anzahl";

$l[\'posname\'] = "Name der Position";
$l[\'posanzahl\'] = "Typ/Anzahl";

$l[\'success_multifields_ava_updated\'] = "Avatare erfolgreich aktualisiert";
$l[\'success_multifields_spezials_updated\'] = "Besonderheiten erfolgreich aktualisiert";
$l[\'success_multifields_quidditch_updated\'] = "Quidditchpositionen erfolgreich aktualisiert";

$l[\'save_multifields_settings\'] = "Speichern";';

	$phpname[6]='../inc/languages/deutsch_sie/admin/multifields_module_meta.lang.php';
	$phpinhalt[6]='<?php
// Language File (Deutsch Formell) fr das MyBB Plugin HP-Listen
//  2018 Celine Geneau
// ---------------------------------------------------
// Last Update: 30.09.2018

$l[\'multifields\'] = "Multi-Listenfelder";

$l[\'multifields_settings\'] = "Multi-Listenfelder";
$l[\'avas\'] = "Multi-Avatare";
$l[\'spezials\'] = "Besondere Fhigkeiten";
$l[\'quidditch\'] = "Quidditchpositionen";
$l[\'can_multifields_dsgvo\'] = "Kann Multi-Listenfelder-Einstellungen vornehmen";';
	
	$phpname[7]='../inc/languages/deutsch_sie/admin/multifields_settings.lang.php';
	$phpinhalt[7]='<?php
// Language File (Deutsch Formell) fr das MyBB Plugin HP-Listen
//  2018 Celine Geneau
// ---------------------------------------------------
// Last Update: 30.09.2018

$l[\'multifields_ava_settings\'] = "Multi-Listenfelder";
$l[\'multifields_ava_settings_desc\'] = "Hier werden die Einstellungen fr die Listenfelder vorgenommen, welche mehrfach verfgbar sind.";

$l[\'avaname\'] = "Name des Avatars";
$l[\'avaanzahl\'] = "Typ/Anzahl";

$l[\'spezialname\'] = "Name der Fhigkeit";
$l[\'spezialanzahl\'] = "Typ/Anzahl";

$l[\'posname\'] = "Name der Position";
$l[\'posanzahl\'] = "Typ/Anzahl";

$l[\'success_multifields_ava_updated\'] = "Avatare erfolgreich aktualisiert";
$l[\'success_multifields_spezials_updated\'] = "Besonderheiten erfolgreich aktualisiert";
$l[\'success_multifields_quidditch_updated\'] = "Quidditchpositionen erfolgreich aktualisiert";

$l[\'save_multifields_settings\'] = "Speichern";';

	$phpname[8]='../inc/languages/english/admin/multifields_module_meta.lang.php';
	$phpinhalt[8]='<?php
// Language file (english) for MyBB Plugin HP-Lists
//  2018 Celine Geneau
// ---------------------------------------------------
// Last Update: 30.09.2018

$l[\'multifields\'] = "Multi-Listfields";

$l[\'multifields_settings\'] = "Multi-Listfields";
$l[\'avas\'] = "Multi-Avatars";
$l[\'spezials\'] = "Special abilitys";
$l[\'quidditch\'] = "Quidditch positions";
$l[\'can_multifields_dsgvo\'] = "Can change options for Multi-Listfields";';
	
	$phpname[9]='../inc/languages/english/admin/multifields_settings.lang.php';
	$phpinhalt[9]='<?php
// Language file (english) for MyBB Plugin HP-Lists
//  2018 Celine Geneau
// ---------------------------------------------------
// Last Update: 30.09.2018

$l[\'multifields_ava_settings\'] = "Multi-Listfields";
$l[\'multifields_ava_settings_desc\'] = "Here, the settings for the list boxes are made, which are available several times.";

$l[\'avaname\'] = "Name of the avatar";
$l[\'avaanzahl\'] = "Type/number";

$l[\'spezialname\'] = "Name of the ability";
$l[\'spezialanzahl\'] = "Type/number";

$l[\'posname\'] = "Name of the position";
$l[\'posanzahl\'] = "Type/number";

$l[\'success_multifields_ava_updated\'] = "Avatars successfully updated";
$l[\'success_multifields_spezials_updated\'] = "Special features successfully updated";
$l[\'success_multifields_quidditch_updated\'] = "Quidditch positions successfully updated";

$l[\'save_multifields_settings\'] = "Save";';

	$phpname[10]='../inc/languages/deutsch_du/admin/seriencharas_settings.lang.php.lang.php';
	$phpinhalt[10]='<?php

$l[\'seriencharas_settings\'] = "Buchcharaktere";
$l[\'seriencharas_add\'] = "Buchcharakter hinzufgen";
$l[\'seriencharas_delete\'] = "Buchcharakter Lschen";
$l[\'seriencharas\'] = "Buchcharaktere";
$l[\'seriencharas_desc\'] = "Einstellung fr die Buchcharaktere";

$l[\'save_seriencharas_settings\'] = "Speichern";
$l[\'delete_seriencharas_settings\'] = "Charakter Lschen";
$l[\'cancel_seriencharas_settings\'] = "Abbrechen";

$l[\'success_seriencharas_updated\'] = "Buchcharaktere erfolgreich gespeichert";
$l[\'success_seriencharas_add\'] = "Buchcharaktere erfolgreich eingetragen";
$l[\'success_seriencharas_delete\'] = "Buchcharaktere erfolgreich gelscht";

$l[\'Name\'] = "Name";
$l[\'Name_desc\'] = "Bitte den vollen Namen des Charakters angeben";
$l[\'Username\'] = "Benutzername";
$l[\'Username_desc\'] = "Bitte den Benutzernamen des Charakters angeben";
$l[\'Alter\'] = "Alter";
$l[\'Alter_desc\'] = "Bitte das Alter des Charakters angeben";
$l[\'Geschlecht\'] = "Geschlecht";
$l[\'Geschlecht_desc\'] = "Bitte das Geschlecht des Charakters angeben";
$l[\'Gruppe\'] = "Gruppe";
$l[\'Gruppe_desc\'] = "Bitte die Zugehrigkeit des Charakters angeben";
$l[\'Deleten\'] = "Aktionen";

$l[\'error_missing_name\'] = "Der Name fehlt";
$l[\'error_user_exists\'] = "Der Benutzername existiert bereits";
$l[\'error_missing_usernama\'] = "Der Benutzername fehlt";
$l[\'error_missing_altere\'] = "Das Alter fehlt";
$l[\'error_missing_user\'] = "Es wurde kein Buchcharaktere ausgewhlt!";

$l[\'delete_seriencharas_realy_delete\'] = \'<center>Willst du den Buchcharakter {$charaname} wirklich l&ouml;schen?</center>\';';

	$phpname[11]='../inc/languages/deutsch_du/admin/seriencharas_module_meta.lang.php.lang.php';
	$phpinhalt[11]='<?php

$l[\'seriencharas\'] = "Buchcharakter";
$l[\'seriencharas_add\'] = "Buchcharakter hinzufgen";
$l[\'seriencharas_settings\'] = "Buchcharakter Einstellungen";
$l[\'can_manage_charas\'] = "Kann Buchcharakter-Einstellungen vornehmen";';

	$phpname[10]='../inc/languages/deutsch_sie/admin/seriencharas_settings.lang.php.lang.php';
	$phpinhalt[10]='<?php

$l[\'seriencharas_settings\'] = "Buchcharaktere";
$l[\'seriencharas_add\'] = "Buchcharakter hinzufgen";
$l[\'seriencharas_delete\'] = "Buchcharakter Lschen";
$l[\'seriencharas\'] = "Buchcharaktere";
$l[\'seriencharas_desc\'] = "Einstellung fr die Buchcharaktere";

$l[\'save_seriencharas_settings\'] = "Speichern";
$l[\'delete_seriencharas_settings\'] = "Charakter Lschen";
$l[\'cancel_seriencharas_settings\'] = "Abbrechen";

$l[\'success_seriencharas_updated\'] = "Buchcharaktere erfolgreich gespeichert";
$l[\'success_seriencharas_add\'] = "Buchcharaktere erfolgreich eingetragen";
$l[\'success_seriencharas_delete\'] = "Buchcharaktere erfolgreich gelscht";

$l[\'Name\'] = "Name";
$l[\'Name_desc\'] = "Bitte den vollen Namen des Charakters angeben";
$l[\'Username\'] = "Benutzername";
$l[\'Username_desc\'] = "Bitte den Benutzernamen des Charakters angeben";
$l[\'Alter\'] = "Alter";
$l[\'Alter_desc\'] = "Bitte das Alter des Charakters angeben";
$l[\'Geschlecht\'] = "Geschlecht";
$l[\'Geschlecht_desc\'] = "Bitte das Geschlecht des Charakters angeben";
$l[\'Gruppe\'] = "Gruppe";
$l[\'Gruppe_desc\'] = "Bitte die Zugehrigkeit des Charakters angeben";
$l[\'Deleten\'] = "Aktionen";

$l[\'error_missing_name\'] = "Der Name fehlt";
$l[\'error_user_exists\'] = "Der Benutzername existiert bereits";
$l[\'error_missing_usernama\'] = "Der Benutzername fehlt";
$l[\'error_missing_altere\'] = "Das Alter fehlt";
$l[\'error_missing_user\'] = "Es wurde kein Buchcharaktere ausgewhlt!";

$l[\'delete_seriencharas_realy_delete\'] = \'<center>Wollen Sie den Buchcharakter {$charaname} wirklich l&ouml;schen?</center>\';';

	$phpname[11]='../inc/languages/deutsch_sie/admin/seriencharas_module_meta.lang.php.lang.php';
	$phpinhalt[11]='<?php

$l[\'seriencharas\'] = "Buchcharakter";
$l[\'seriencharas_add\'] = "Buchcharakter hinzufgen";
$l[\'seriencharas_settings\'] = "Buchcharakter Einstellungen";
$l[\'can_manage_charas\'] = "Kann Buchcharakter-Einstellungen vornehmen";';

	$phpname[10]='../inc/languages/english/admin/seriencharas_settings.lang.php.lang.php';
	$phpinhalt[10]='<?php

$l[\'seriencharas_settings\'] = "Book character";
$l[\'seriencharas_add\'] = "Add book character";
$l[\'seriencharas_delete\'] = "Delete book character";
$l[\'seriencharas\'] = "Book character";
$l[\'seriencharas_desc\'] = "Settings for book characters";

$l[\'save_seriencharas_settings\'] = "Save";
$l[\'delete_seriencharas_settings\'] = "delete book character";
$l[\'cancel_seriencharas_settings\'] = "Cancel";

$l[\'success_seriencharas_updated\'] = "Book characters saved successfully";
$l[\'success_seriencharas_add\'] = "Book characters added successfully";
$l[\'success_seriencharas_delete\'] = "Book characters deleted successfully";

$l[\'Name\'] = "Name";
$l[\'Name_desc\'] = "Please specify the full name of the character";
$l[\'Username\'] = "Username";
$l[\'Username_desc\'] = "Please enter the username of the character";
$l[\'Alter\'] = "Age";
$l[\'Alter_desc\'] = "Please specify the age of the character";
$l[\'Geschlecht\'] = "Gender";
$l[\'Geschlecht_desc\'] = "Please specify the gender of the character";
$l[\'Gruppe\'] = "affiliation";
$l[\'Gruppe_desc\'] = "Please specify the affiliation of the character";
$l[\'Deleten\'] = "Action";


$l[\'error_missing_name\'] = "The name is missing";
$l[\'error_user_exists\'] = "The username allready exists";
$l[\'error_missing_usernama\'] = "The username is missing";
$l[\'error_missing_altere\'] = "The age is missing";
$l[\'error_missing_user\'] = "No book characters were selected!";

$l[\'delete_seriencharas_realy_delete\'] = \'<center>Do you realy want to delete the book character {$charaname}?</center>\';';

	$phpname[11]='../inc/languages/english/admin/seriencharas_module_meta.lang.php.lang.php';
	$phpinhalt[11]='<?php

$l[\'seriencharas\'] = "Book character";
$l[\'seriencharas_add\'] = "Add book character";
$l[\'seriencharas_settings\'] = "Book character settings";
$l[\'can_manage_charas\'] = "can make book character-setting";';
	
	
	$i=0;
	$max=count($phpname);
	while($i<$max)
	{
		$filename=$phpname[$i];
		$inhalt=$phpinhalt[$i];
		
		$handle = fopen ($mybb->settings['bburl'].$filename, 'a+');
		fwrite ($handle, $inhalt);
		fclose ($handle);
		$i++;
	}
	
	require_once MYBB_ROOT."/inc/adminfunctions_templates.php";
	//Template editpost bearbeiten*/
	$tplname[0]='editpost';
	$searchpattern[0]='{$menu_calendar}';
	$myVar[0]=' <a href="/listen.php">$lang->hp_listen_listenname</a>';
	
	$i=0;
	$max=count($tplname);
	while($i<$max)
	{
		find_replace_templatesets($tplname[$i],"#".preg_quote($searchpattern[$i])."#i",$searchpattern[$i].$myVar[$i]);
		$i++;
	}
	
	$templatelname[0]='listen_ags_namebit';
	$template[0] = '<td width="33%"><div class="listspechead">{$gruppe}</div>
<div class="listblood">{$userbit}</div>
</td>';
	
	$templatelname[1]='listen_ags_namen_bit';
	$template[1] = '<span class="smalltext">{$username}</span> <br />';
	
	$templatelname[2]='listen_ags_tablebit';
	$template[2] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[3]='listen_avatare';
	$template[3] = '<html>
<head>
<title>{$listenname} - {$title}</title>
{$headerinclude}
</head>
<body>
{$header}
<div align="justify" class="trow2" style="padding: 10px">
	<div class="listhead1">$title</div>
	<table style="width: 100%;" cellpadding="5" cellspacing="0"><tr><td><div class="listhead2">$male A - F</div></td><td><div class="listhead2">$female A - F</div></td></tr>
		<tr><td valign="top"><div class="listavatext">{$male1}</div></td><td valign="top"><div class="listavatext">{$female1}</div></td></tr>
	<tr><td><div class="listhead2">$male G - K</div></td><td><div class="listhead2">$female G - K</div></td></tr>
		<tr><td valign="top"><div class="listavatext">{$male2}</div></td><td valign="top"><div class="listavatext">{$female2}</div></td></tr>
	<tr><td><div class="listhead2">$male L - P</div></td><td><div class="listhead2">$female L - P</div></td></tr>
		<tr><td valign="top"><div class="listavatext">{$male3}</div></td><td valign="top"><div class="listavatext">{$female3}</div></td></tr>
	<tr><td><div class="listhead2">$male Q - U</div></td><td><div class="listhead2">$female Q - U</div></td></tr>
	<tr><td valign="top"><div class="listavatext">{$male4}</div></td><td valign="top"><div class="listavatext">{$female4}</div></td></tr>
	<tr><td><div class="listhead2">$male V - Z</div></td><td><div class="listhead2">$female V - Z</div></td></tr>
	<tr><td valign="top"><div class="listavatext">{$male5}</div></td><td valign="top"><div class="listavatext">{$female5}</div></td></tr></table>
	{$nichtentfernen}
</div>
{$footer}
</body>
</html>';
	
	$templatelname[4]='listen_avatare_userbit';
	$template[4] = '<span class="smalltext">{$username} ({$avatar})</span> <br />';
	
	$templatelname[5]='listen_band_namebit';
	$template[5] = '<td width="33%"><div class="listspechead">{$gruppe}</div>
<div class="listblood">{$userbit}</div>
</td>';
	
	$templatelname[6]='listen_band_namen_bit';
	$template[6] = '<span class="smalltext">{$username}</span> <br />';
	
	$templatelname[7]='listen_band_tablebit';
	$template[7] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[8]='listen_berufe_bit';
	$template[8] = '<span class=\"smalltext\">{$username} ({$beruf})</span> <br />';
	
	$templatelname[9]='listen_berufe_namebit';
	$template[9] = '<td width="33%"><div class="listspechead">{$gruppe}</div>
<div class="listblood">{$userbit}</div>
</td>';
	
	$templatelname[10]='listen_berufe_tablebit';
	$template[10] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[11]='listen_besonderheiten_bit';
	$template[11] = '<span class="smalltext">{$username} ({$gruppe})</span> <br />';
	
	$templatelname[12]='listen_besonderheiten_namebit';
	$template[12] = '<td width="33%"><div class="listspechead">{$gruppe}</div>
<div class="listspec">	{$userbit}</div>
</td>';
	
	$templatelname[13]='listen_besonderheiten_tablebit';
	$template[13] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[14]='listen_beziehungsliste_bit';
	$template[14] = '<span class="smalltext">{$username} ({$partner})</span> <br />';
	
	$templatelname[15]='listen_beziehungsliste_namebit';
	$template[15] = '<td width="33%"><div class="listspechead">{$gruppe}</div>
	<div class="listspec">{$userbit}</div>
</td>';
	
	$templatelname[16]='listen_beziehungsliste_tablebit';
	$template[16] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[17]='listen_blutstatus_namebit';
	$template[17] = '<td width="33%"><div class="listspechead">{$gruppe}</div>
<div class="listblood">{$userbit}</div>
</td>';
	
	$templatelname[18]='listen_blutstatus_namen_bit';
	$template[18] = '<span class="smalltext">{$username}</span> <br />';
	
	$templatelname[19]='listen_blutstatus_tablebit';
	$template[19] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[20]='listen_charakter_namebit';
	$template[20] = '<td width="33%"><div class="listspechead">{$gruppe}</div>
	<div class="listblood">{$userbit}</div>
</td>';
	
	$templatelname[21]='listen_charakter_namen_bit';
	$template[21] = '<span class="smalltext">{$username}</span> <br />';
	
	$templatelname[22]='listen_charakter_tablebit';
	$template[22] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[23]='listen_classes_div';
	$template[23] = '<table><tr><td colspan="2"><div align="center">$haus</div></td></tr>
<tr><td> {$male}</td>
<td>{$female}</td></tr></table>
<div style="clear: both;"></div>';
	
	$templatelname[24]='listen_classes_divbit';
	$template[24] = '<div class="listhousetext"><div align="center">{$info}</div>
<div style="float: left; widht=50%;">{$malebit}</div>
<div style="float: right; widht=50%;">{$femalebit}</div></div>
<div style="clear: both;"></div>';
	
	$templatelname[25]='listen_div';
	$template[25] = '<div style="float: left;">{$a}</div>
<div style="float: right;">{$b}</div>
<div style="clear: both;"></div>';
	
	$templatelname[26]='listen_div_bit';
	$template[26] = '{$haus}
{$userbit}';
	
	$templatelname[27]='listen_gesinnung_namebit';
	$template[27] = '<td width="33%"><div class="listspechead">{$gruppe}</div>
<div class="listblood">{$userbit}</div>
</td>';
	
	$templatelname[28]='listen_gesinnung_namen_bit';
	$template[28] = '<span class="smalltext">{$username}</span> <br />';
	
	$templatelname[29]='listen_gesinnung_tablebit';
	$template[29] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[30]='listen_kurs_namebit';
	$template[30] = '<td width="33%"><div class="listspechead">{$gruppe}</div>
<div class="listblood">{$userbit}</div>
</td>';
	
	$templatelname[31]='listen_kurs_namen_bit';
	$template[31] = '<span class="smalltext">{$username}</span> <br />';
	
	$templatelname[32]='listen_kurs_tablebit';
	$template[32] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[33]='listen_main';
	$template[33] = '<html>
<head>
<title>{$listenname} - {$title}</title>
{$headerinclude}
</head>
<body>
{$header}
<div align="center" class="trow2" style="padding: 10px">
	<div class="listhead1">{$title}</div>
	<h2><a href="listen.php?action=student">{$titleint}</a></h2>
	<br><a href="listen.php?action=zweitcharas">{$zweitcharas}</a>
	<br><a href="listen.php?action=avatare">{$avatare}</a>
	<br><a href="listen.php?action=besonderheiten">{$besonderheiten}</a>
	<br><a href="listen.php?action=beziehungsliste">{$beziehungsliste}</a>
	<br><a href="listen.php?action=blutstatus">{$blutstatus}</a>
	<br><a href="listen.php?action=charaktere">{$charaktere}</a>
	<br><a href="listen.php?action=namen">{$namen}</a>
	<br><a href="listen.php?action=patronus">{$patronus}</a>
	<br><a href="listen.php?action=reinblut">{$reinblut}</a>
	<br><a href="listen.php?action=gesinnung">{$gesinnung}</a>
	<br><a href="listen.php?action=berufe">{$berufe}</a>
	<br><a href="listen.php?action=seriencharas">{$seriencharas}</a>
</div>
{$footer}
</body>
</html>';
	
	$templatelname[34]='listen_namebit';
	$template[34] = '<td width="33%"><div class="listspechead">{$gruppe}</div>
<div class="listblood">{$userbit}</div>
</td>';
	
	$templatelname[35]='listen_namen';
	$template[35] = '<html>
<head>
<title>{$listenname} - {$title}</title>
{$headerinclude}
</head>
<body>
{$header}
<div align="justify" class="trow2" style="padding: 10px">
	<div class="listhead1">$title</div>
    <table style="width: 100%;" cellpadding="5" cellspacing="0"><tr>
        <td valign="top" style="width: 35%;"><div class="listheadnames2">VORNAMEN WEIBLICH</div></td>
			<td valign="top" style="width: 35%;"><div class="listheadnames2">VORNAMEN MNNLICH</div></td> 
			<td valign="top" style="width: 35%;"><div class="listheadnames2">NACHNAMEN</div></td></tr><tr>
        <tr><td valign="top"><div class="listnametext">{$vweiblich1}{$vweiblich2}{$vweiblich3}{$vweiblich4}{$vweiblich5}</div></td>
              <td valign="top"><div class="listnametext">{$nmannlich1}{$nmannlich2}{$nmannlich3}{$nmannlich4}{$nmannlich5}</div></td>
              <td valign="top"><div class="listnametext">{$nachname}</div></td></tr></table>
{$footer}
</body>
</html>';
	
	$templatelname[36]='listen_namen_bit';
	$template[36] = '<span class="smalltext">{$username}</span> <br />';
	
	$templatelname[37]='listen_pagebit';
	$template[37] = '<html>
<head>
<title>{$listenname} - {$title}</title>
{$headerinclude}
</head>
<body>
{$header}
<div align="center" class="trow2" style="padding: 10px">
	<div class="listhead1">{$title}</div>
	<table style="width: 100%;" cellpadding="5" cellspacing="0">
		{$tablebit}
	</table>
</div>
{$footer}
</body>
</html>';
	
	$templatelname[38]='listen_patronus_bit';
	$template[38] = '<span class=\"smalltext\">{$username} ({$patronus})</span> <br />';
	
	$templatelname[39]='listen_patronus_namebit';
	$template[39] = '<td width="33%"><div class="listspechead">{$gruppe}</div>
<div class="listblood">{$userbit}</div>
</td>';
	
	$templatelname[40]='listen_patronus_tablebit';
	$template[40] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[41]='listen_quidditch_div';
	$template[41] = '<div style="float: left;">{$a}</div>
<div style="float: right;">{$b}</div>
<div style="clear: both;"></div>';
	
	$templatelname[42]='listen_quidditch_div_bit';
	$template[42] = '<div>{$haus}
{$userbit}
</div>';
	
	$templatelname[43]='listen_quidditch_namebit';
	$template[43] = '<td><div class="listquiddhead">{$gruppe}</div>
<div class="listquidd">{$userbit}<br></div>
</td>';
	
	$templatelname[44]='listen_quidditch_namen_bit';
	$template[44] = '<span class="smalltext">{$username}</span> <br />';
	
	$templatelname[45]='listen_quidditch_tablebit';
	$template[45] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[46]='listen_reinblut_namebit';
	$template[46] = '<td width="33%"><div class="listspechead">{$gruppe}</div>
<div class="listblood">{$userbit}</div>
</td>';
	
	$templatelname[47]='listen_reinblut_namen_bit';
	$template[47] = '<span class="smalltext" style="padding:5px;">{$username}</span> <br />';
	
	$templatelname[48]='listen_reinblut_tablebit';
	$template[48] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[49]='listen_schulpos_classes_div';
	$template[49] = '<tr><td colspan="2"><div class="listschulheadbig">$haus</div></td>
<tr><td><div class="listschul1">{$male}</div></td><td><div class="listschul1">{$female}</div></td></tr></table>
<div style="clear: both;"></div>';
	
	$templatelname[50]='listen_schulpos_div';
	$template[50] = '<table>
	<tr>	<td>{$a}</td>
		<td>{$b}</td>
	</tr>
</table>';
	
	$templatelname[51]='listen_schulpos_div_bit';
	$template[51] = '<div class="listschulhead">{$haus}</div>
<div class="listschul">{$userbit}</div>';
	
	$templatelname[52]='listen_schulpos_namebit';
	$template[52] = '<td>
	{$userbit}
</td>';
	
	$templatelname[53]='listen_schulpos_namen_bit';
	$template[53] = '<span class="smalltext">{$username}</span>';
	
	$templatelname[54]='listen_schulpos_tablebit';
	$template[54] = '<tr>
	<div class="listschul1">{$namebit} </div>
</tr>';
	
	$templatelname[55]='listen_student';
	$template[55] = '<html>
<head>
<title>{$listenname} - {$title}</title>
{$headerinclude}
</head>
<body>
{$header}
<div align="center" class="trow2" style="padding: 10px">
	<div class="listhead1">{$title}</div>
	<h2><a href="listen.php?action=general">{$titleext}</a></h2>
	<br><a href="listen.php?action=classes">{$classes}</a>
	<br><a href="listen.php?action=kursliste">{$kursliste}</a>
	<br><a href="listen.php?action=quidditch">{$quidditch}</a>
	<br><a href="listen.php?action=clubs">{$clubs}</a>
	<br><a href="listen.php?action=zeitung">{$zeitung}</a>
	<br><a href="listen.php?action=band">{$band}</a>
	<br><a href="listen.php?action=positionen">{$positionen}</a>
</div>
{$footer}
</body>
</html>';
	
	$templatelname[56]='listen_tablebit';
	$template[56] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[57]='listen_wsw_classes_div';
	$template[57] = '<table><tr><td colspan="2"><div align="center"><div class="listhead1">$haus</div></div></td></tr>
<tr><td><div class="listhouseminihead"> {$male}</div></td>
<td><div class="listhouseminihead">{$female}</div></td></tr></table>
<div style="clear: both;"></div>';
	
	$templatelname[58]='listen_wsw_classes_divbit';
	$template[58] = '<div class="listhousetext"><div align="center">{$info}</div>
<div style="float: left; widht=50%;">{$malebit}</div>
<div style="float: right; widht=50%;">{$femalebit}</div></div>
<div style="clear: both;"></div>';
	
	$templatelname[59]='listen_wsw_div';
	$template[59] = '<div style="float: left;">{$a}</div>
<div style="float: right;">{$b}</div>
<div style="clear: both;"></div>';
	
	$templatelname[60]='listen_wsw_namebit';
	$template[60] = '<td width="33%"><div class="minfo3b"><h4>{$gruppe}</h4></div>
	{$userbit}
</td>';
	
	$templatelname[61]='listen_wsw_namen_bit';
	$template[61] = '<span class="smalltext">{$username}</span> <br />';
	
	$templatelname[62]='listen_wsw_tablebit';
	$template[62] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[63]='listen_zeitung_namebit';
	$template[63] = '<td width="33%"><div class="listspechead">{$gruppe}</div>
<div class="listblood">{$userbit}</div>
</td>';
	
	$templatelname[64]='listen_zeitung_namen_bit';
	$template[64] = '<span class="smalltext">{$username}</span> <br />';
	
	$templatelname[65]='listen_zeitung_tablebit';
	$template[65] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[66]='listen_seriencharas_namebit';
	$template[66] = '<td width="$weite"$colls><div class="listspechead">{$gruppe}</div>
	<div class="listblood">{$userbit}</div>
</td>';
	
	$templatelname[67]='listen_seriencharas_namen_bit';
	$template[67] = '<span class="smalltext">{$username}</span> <br />';
	
	$templatelname[69]='listen_seriencharas_subtablebit';
	$template[69] = '<tr>
	{$namebit}
</tr>';
	
	$templatelname[60]='listen_seriencharas_tablebit';
	$template[60] = '<tr>
	<td colspan="4" width="100%"><div class="listhead1"><center>{$group}</center></div><td>
</tr>
{$subtablebit}';
	
	$templatelname[70]='listen_seriencharas_userbit';
	$template[70] = '{$name} ($age)';

	$i=0;
	$max=count($template);
	while($i<$max)
	{
		$insert_array = array(
			'title' => $templatelname[$i],
			'template' => $db->escape_string($template[$i]),
			'sid' => '-1',
			'version' => '',
			'dateline' => time()
		);
		
		$db->insert_query('templates', $insert_array);
		$i++;
	}
}

function hp_listen_deactivate()
{
	global $db, $cache;
	
	
	/*Daten in PHP's ndern*/
	/*Pfad Deutsch-du*/
	$pfad[0]="../inc/languages/deutsch_du/datahandler_user.lang.php";
	$r[0]='$l[\'userdata_missing_required_profile_field\'] = \'Die Angabe im Feld "{1}" fehlt. Bitte korrigiere deine Eingabe.\';';
	$s[0]='$l[\'userdata_missing_required_profile_field\'] = \'Die Angabe im Feld "{1}" fehlt oder ist bereits vergeben. Bitte korrigiere deine Eingabe.\';';
	
	/*Pfad Deutsch-sie*/	
	$pfad[1]="../inc/languages/deutsch_sie/datahandler_user.lang.php";
	$r[1]='$l[\'userdata_missing_required_profile_field\'] = \'Die Angabe im Feld "{1}" fehlt. Bitte korrigieren Sie Ihre Eingabe.\';';
	$s[1]='$l[\'userdata_missing_required_profile_field\'] = \'Die Angabe im Feld "{1}" fehlt oder ist bereits vergeben. Bitte korrigieren Sie Ihre Eingabe.\';';
	
	/*Pfad english*/
	$pfad[2]="../inc/languages/english/datahandler_user.lang.php";
	$r[2]='$l[\'userdata_missing_required_profile_field\'] = \'You did not enter an option for the "{1}" field. Please fill in or select a value for this field.\';';
	$s[2]='$l[\'userdata_missing_required_profile_field\'] = \'You did not enter an option or enter an allready taken option for the "{1}" field. Please fill in or select a value for this field.\';';

	$i=0;
	$max=count($pfad);
	while($i<$max)
	{
		$datei=$pfad[$i];
		$search=$s[$i];
		$replace=$r[$i];
		
		$inhalt = file_get_contents($datei);
		$inhalt = str_replace($search,$replace,$inhalt);
	
		file_put_contents($datei,$inhalt);
		$i++;
	}
	
	
	unlink('../listen.php');
	unlink('../inc/languages/deutsch_du/hp_listen.lang.php');
	unlink('../inc/languages/deutsch_sie/hp_listen.lang.php');
	unlink('../inc/languages/english/hp_listen.lang.php');
	unlink('../inc/languages/deutsch_du/admin/multifields_module_meta.lang.php');
	unlink('../inc/languages/deutsch_sie/admin/multifields_module_meta.lang.php');
	unlink('../inc/languages/english/admin/multifields_module_meta.lang.php');
	unlink('../inc/languages/deutsch_du/admin/multifields_settings.lang.php');
	unlink('../inc/languages/deutsch_sie/admin/multifields_settings.lang.php');
	unlink('../inc/languages/english/admin/multifields_settings.lang.php');
	

	require_once MYBB_ROOT."/inc/adminfunctions_templates.php";
	//Template editpost bearbeiten*/
	$tplname[0]='editpost';
	$searchpattern[0]='{$menu_calendar}';
	$myVar[0]=' <a href="/listen.php">$lang->hp_listen_listenname</a>';
	
	$i=0;
	$max=count($pfad);
	while($i<$max)
	{
		find_replace_templatesets
		(
		$tplname[$i],
		"#" . preg_quote($searchpattern[$i].$myVar[$i]) . "#i",
		$searchpattern[$i]
		);
		$i++;
	}

	$db->delete_query("templates", "title = 'listen_ags_namebit'");
	$db->delete_query("templates", "title = 'listen_ags_namen_bit'");
	$db->delete_query("templates", "title = 'listen_ags_tablebit'");
	$db->delete_query("templates", "title = 'listen_avatare'");
	$db->delete_query("templates", "title = 'listen_avatare_userbit'");
	$db->delete_query("templates", "title = 'listen_band_namebit'");
	$db->delete_query("templates", "title = 'listen_band_namen_bit'");
	$db->delete_query("templates", "title = 'listen_band_tablebit'");
	$db->delete_query("templates", "title = 'listen_berufe_bit'");
	$db->delete_query("templates", "title = 'listen_berufe_namebit'");
	$db->delete_query("templates", "title = 'listen_berufe_tablebit'");
	$db->delete_query("templates", "title = 'listen_besonderheiten_bit'");
	$db->delete_query("templates", "title = 'listen_besonderheiten_namebit'");
	$db->delete_query("templates", "title = 'listen_besonderheiten_tablebit'");
	$db->delete_query("templates", "title = 'listen_beziehungsliste_bit'");
	$db->delete_query("templates", "title = 'listen_beziehungsliste_namebit'");
	$db->delete_query("templates", "title = 'listen_beziehungsliste_tablebit'");
	$db->delete_query("templates", "title = 'listen_blutstatus_namebit'");
	$db->delete_query("templates", "title = 'listen_blutstatus_namen_bit'");
	$db->delete_query("templates", "title = 'listen_blutstatus_tablebit'");
	$db->delete_query("templates", "title = 'listen_charakter_namebit'");
	$db->delete_query("templates", "title = 'listen_charakter_namen_bit'");
	$db->delete_query("templates", "title = 'listen_charakter_tablebit'");
	$db->delete_query("templates", "title = 'listen_classes_div'");
	$db->delete_query("templates", "title = 'listen_classes_divbit'");
	$db->delete_query("templates", "title = 'listen_div'");
	$db->delete_query("templates", "title = 'listen_div_bit'");
	$db->delete_query("templates", "title = 'listen_gesinnung_namebit'");
	$db->delete_query("templates", "title = 'listen_gesinnung_namen_bit'");
	$db->delete_query("templates", "title = 'listen_gesinnung_tablebit'");
	$db->delete_query("templates", "title = 'listen_kurs_namebit'");
	$db->delete_query("templates", "title = 'listen_kurs_namen_bit'");
	$db->delete_query("templates", "title = 'listen_kurs_tablebit'");
	$db->delete_query("templates", "title = 'listen_main'");
	$db->delete_query("templates", "title = 'listen_namebit'");
	$db->delete_query("templates", "title = 'listen_namen'");
	$db->delete_query("templates", "title = 'listen_namen_bit'");
	$db->delete_query("templates", "title = 'listen_pagebit'");
	$db->delete_query("templates", "title = 'listen_patronus_bit'");
	$db->delete_query("templates", "title = 'listen_patronus_namebit'");
	$db->delete_query("templates", "title = 'listen_patronus_tablebit'");
	$db->delete_query("templates", "title = 'listen_quidditch_div'");
	$db->delete_query("templates", "title = 'listen_quidditch_div_bit'");
	$db->delete_query("templates", "title = 'listen_quidditch_namebit'");
	$db->delete_query("templates", "title = 'listen_quidditch_namen_bit'");
	$db->delete_query("templates", "title = 'listen_quidditch_tablebit'");
	$db->delete_query("templates", "title = 'listen_reinblut_namebit'");
	$db->delete_query("templates", "title = 'listen_reinblut_namen_bit'");
	$db->delete_query("templates", "title = 'listen_reinblut_tablebit'");
	$db->delete_query("templates", "title = 'listen_schulpos_classes_div'");
	$db->delete_query("templates", "title = 'listen_schulpos_div'");
	$db->delete_query("templates", "title = 'listen_schulpos_div_bit'");
	$db->delete_query("templates", "title = 'listen_schulpos_namebit'");
	$db->delete_query("templates", "title = 'listen_schulpos_namen_bit'");
	$db->delete_query("templates", "title = 'listen_schulpos_tablebit'");
	$db->delete_query("templates", "title = 'listen_student'");
	$db->delete_query("templates", "title = 'listen_tablebit'");
	$db->delete_query("templates", "title = 'listen_wsw_classes_div'");
	$db->delete_query("templates", "title = 'listen_wsw_classes_divbit'");
	$db->delete_query("templates", "title = 'listen_wsw_div'");
	$db->delete_query("templates", "title = 'listen_wsw_namebit'");
	$db->delete_query("templates", "title = 'listen_wsw_namen_bit'");
	$db->delete_query("templates", "title = 'listen_wsw_tablebit'");
	$db->delete_query("templates", "title = 'listen_zeitung_namebit'");
	$db->delete_query("templates", "title = 'listen_zeitung_namen_bit'");
	$db->delete_query("templates", "title = 'listen_zeitung_tablebit'");
	
	pfad_loeschen('../admin/modules/multifields');
}

function pfad_loeschen($path)
{
    if (is_dir($path) === true) {
        $files = array_diff(scandir($path), array('.', '..'));
        
        foreach ($files as $file) {
          pfad_loeschen(realpath($path) . '/' . $file);
        }
        return rmdir($path);
    }
    
    else if (is_file($path) === true) {
        return unlink($path);
    }
    return false;
}  

function hp_listen_install()
{
	global $db, $cache, $lang;
	$plugins_cache = $cache->read("plugins");
	if (!isset($plugins_cache['active']['hp_wob']))
	{
		global $page, $lang;
		$lang->load('hp_listen');
		$page->output_confirm_action('index.php?module=config-plugins&action=deactivate&uninstall=1&plugin=hp_wob', $lang->hp_listen_activate_message, $lang->hp_listen_activate);
	}
	else hp_listen_install_do();
}

function hp_listen_install_do()
{
	global $db, $cache, $lang;
	$lang->load('hp_listen');
	
	$query = $db->query("
		CREATE TABLE ".TABLE_PREFIX."quidditch (
		position text(255),
		anzahl int(11)
		) 
	");
	$updated_pid = array(
	"position" => "Platzhalter",
	"anzahl" => 1
	);
	$db->insert_query("quidditch", $updated_pid);
	
	$query = $db->query("
		CREATE TABLE ".TABLE_PREFIX."spezials (
		spezial text(255),
		anzahl int(11)
		) 
	");
	
	$query = $db->query("
		CREATE TABLE ".TABLE_PREFIX."multiava (
		avaname text(255),
		anzahl int(11)
		) 
	");
	
	$query = $db->simple_select("profilefields", 'fid', "wob='1'");
	$fidinfo = $db->fetch_array($query);
	
	$userarray=array();
	if($fidinfo['fid']>0)
	{
		$query = $db->simple_select("userfields", 'ufid,fid'.$fidinfo['fid'], "");
		while($row=$db->fetch_array($query)) $userarray[$row['ufid']]=$row['fid'.$fidinfo['fid']];
	}
	
	
	$query = $db->simple_select("profilefields", 'fid', "");
	while($row=$db->fetch_array($query))
	{
		$fid=$row['fid'];
		
		if($fid>0)
		{
			$db->delete_query("profilefields", "fid='{$fid}'");
			$db->write_query("ALTER TABLE ".TABLE_PREFIX."userfields DROP fid{$fid}");
		}
	}
	
	$db->write_query("ALTER TABLE ".TABLE_PREFIX."profilefields AUTO_INCREMENT=1");
	
	$cache->update_profilefields();
	
	$db->add_column("usergroups", "maingroupforlist", "int(10) NOT NULL DEFAULT '0'");
	
	$usergroup_permissions = array(
	"isbannedgroup" => 0,
	"canview" => 1,
	"canviewthreads" => 1,
	"canviewprofiles" => 1,
	"candlattachments" => 1,
	"canviewboardclosed" => 1,
	"canpostthreads" => 1,
	"canpostreplys" => 1,
	"canpostattachments" => 1,
	"canratethreads" => 1,
	"modposts" => 0,
	"modthreads" => 0,
	"modattachments" => 0,
	"mod_edit_posts" => 0,
	"caneditposts" => 1,
	"candeleteposts" => 1,
	"candeletethreads" => 1,
	"caneditattachments" => 1,
	"canviewdeletionnotice" => 1,
	"canpostpolls" => 1,
	"canvotepolls" => 1,
	"canundovotes" => 0,
	"canusepms" => 1,
	"cansendpms" => 1,
	"cantrackpms" => 1,
	"candenypmreceipts" => 1,
	"pmquota" => 100,
	"maxpmrecipients" => 5,
	"cansendemail" => 1,
	"cansendemailoverride" => 0,
	"maxemails" => 4,
	"emailfloodtime" => 5,
	"canviewmemberlist" => 1,
	"canviewcalendar" => 1,
	"canaddevents" => 1,
	"canbypasseventmod" => 0,
	"canmoderateevents" => 0,
	"canviewonline" => 1,
	"canviewwolinvis" => 0,
	"canviewonlineips" => 0,
	"cancp" => 0,
	"issupermod" => 0,
	"cansearch" => 1,
	"canusercp" => 1,
	"canuploadavatars" => 1,
	"canratemembers" => 1,
	"canchangename" => 0,
	"canbereported" => 0,
	"canchangewebsite" => 1,
	"showforumteam" => 0,
	"usereputationsystem" => 1,
	"cangivereputations" => 1,
	"candeletereputations" => 1,
	"reputationpower" => 1,
	"maxreputationsday" => 5,
	"maxreputationsperuser" => 0,
	"maxreputationsperthread" => 0,
	"candisplaygroup" => 0,
	"attachquota" => 5000,
	"cancustomtitle" => 0,
	"canwarnusers" => 0,
	"canreceivewarnings" => 1,
	"maxwarningsday" => 0,
	"canmodcp" => 0,
	"showinbirthdaylist" => 0,
	"canoverridepm" => 0,
	"canusesig" => 0,
	"canusesigxposts" => 0,
	"signofollow" => 0,
	"edittimelimit" => 0,
	"maxposts" => 0,
	"showmemberlist" => 1,
	"canmanageannounce" => 0,
	"canmanagemodqueue" => 0,
	"canmanagereportedcontent" => 0,
	"canviewmodlogs" => 0,
	"caneditprofiles" => 0,
	"canbanusers" => 0,
	"canviewwarnlogs" => 0,
	"canuseipsearch" => 0
	);

	$student_usergroup = array
	(
		"type" => 2,
		"title" => $db->escape_string($lang->hp_listen_student_name),
		"description" => $db->escape_string($lang->hp_listen_student_description),
		"namestyle" => $db->escape_string("{username}"),
		"usertitle" => "",
		"wobgroup" => 0,
		"stars" => 0,
		"starimage" => "images/star.png",
		"disporder" => 0,
		"maingroupforlist" => 2
	);
	
	$adult_usergroup = array
	(
		"type" => 2,
		"title" => $db->escape_string($lang->hp_listen_adult_name),
		"description" => $db->escape_string($lang->hp_listen_adult_description),
		"namestyle" => $db->escape_string("{username}"),
		"usertitle" => "",
		"wobgroup" => 0,
		"stars" => 0,
		"starimage" => "images/star.png",
		"disporder" => 0,
		"maingroupforlist" => 1
	);
	
	$query = $db->simple_select("usergroups", "*", "gid='2'");
	$existing_usergroup = $db->fetch_array($query);
	foreach(array_keys($usergroup_permissions) as $field)
	{
		$student_usergroup[$field] = $existing_usergroup[$field];
		$adult_usergroup[$field] = $existing_usergroup[$field];
	}
	
	$studentgid = $db->insert_query("usergroups", $student_usergroup);
	$adultgid = $db->insert_query("usergroups", $adult_usergroup);
	
	$query = $db->simple_select("forumpermissions", "*", "gid='2'");
	while($forum_permission = $db->fetch_array($query))
	{
		unset($forum_permission['pid']);
		$forum_permission['gid'] = $studentgid;
		$db->insert_query("forumpermissions", $forum_permission);
		
		$forum_permission['gid'] = $adultgid;
		$db->insert_query("forumpermissions", $forum_permission);
	}
	
	// Update the caches
	$cache->update_usergroups();
	$cache->update_forumpermissions();
	
	
	$query = $db->simple_select("users", "uid, additionalgroups, vorlagegruppe", "");
	while($row = $db->fetch_array($query))
	{
		$uid=$row['uid'];
		
		if($row['vorlagegruppe']==1) $gid=$adultgid;
		else $gid=$studentgid;
		
		if(strlen($row['additionalgroups'])>1) $additionalgroups=$row['additionalgroups'].",".$gid;
		else $additionalgroups=$gid;
		
		$update_user = array(
		"additionalgroups" => $additionalgroups,
		);
		$db->update_query("users", $update_user, "uid='".$uid."'");
	}
	
	$editablebyarray[1]="-1";
	$editablebyarray[2]="-1";
	$editablebyarray[3]="-1";
	$editablebyarray[4]="-1";
	$editablebyarray[5]="-1";
	$editablebyarray[6]="-1";
	$editablebyarray[7]="-1";
	$editablebyarray[8]="-1";
	$editablebyarray[9]="-1";
	$editablebyarray[10]="-1";	
	$editablebyarray[11]="-1";
	
	$editablebyarray[12]=$adultgid;
	$editablebyarray[25]=$adultgid;
	
	$editablebyarray[13]=$studentgid;
	$editablebyarray[14]=$studentgid;
	$editablebyarray[15]=$studentgid;
	$editablebyarray[16]=$studentgid;
	$editablebyarray[17]=$studentgid;
	$editablebyarray[18]=$studentgid;
	$editablebyarray[19]=$studentgid;
	$editablebyarray[20]=$studentgid;
	$editablebyarray[21]="-1";
	$editablebyarray[22]="-1";
	$editablebyarray[23]="-1";
	$editablebyarray[24]="-1";
	$editablebyarray[25]="-1";
	$editablebyarray[26]="-1";
	
	$i=0;
	while($i<26)
	{
		$i++;
		
		
		$name="hp_listen_name_".$i;
		$description="hp_listen_description_".$i;
		$type="hp_listen_type_".$i;
		$length="hp_listen_length_".$i;
		$maxlength="hp_listen_maxlength_".$i;
		$required="hp_listen_required_".$i;
		$registration="hp_listen_registration_".$i;
		$profile="hp_listen_profile_".$i;
		$viewableby="hp_listen_viewableby_".$i;
		$editableby=$editablebyarray[$i];
		$postbit="hp_listen_postbit_".$i;
		$wob="hp_listen_wob_".$i;
		
		$new_profile_field = array
		(
			"name" => $db->escape_string($lang->$name),
			"description" => $db->escape_string($lang->$description),
			"disporder" => $db->escape_string($i),
			"type" => $db->escape_string($lang->$type),
			"regex" => "",
			"length" => $db->escape_string($lang->$length),
			"maxlength" => $db->escape_string($lang->$maxlength),
			"required" => $db->escape_string($lang->$required),
			"registration" => $db->escape_string($lang->$registration),
			"profile" => $db->escape_string($lang->$profile),
			"viewableby" => $db->escape_string($lang->$viewableby),
			"editableby" => $db->escape_string($editableby),
			"postbit" => $db->escape_string($lang->$postbit),
			"postnum" => 0,
			"allowhtml" => 0,
			"allowmycode" => 0,
			"allowsmilies" => 0,
			"allowimgcode" => 0,
			"allowvideocode" => 0,
			"wob" => $db->escape_string($lang->$wob)
		);
		
		$fid = $db->insert_query("profilefields", $new_profile_field);
		
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."userfields ADD fid{$fid} TEXT");
		
		$cache->update_profilefields();
	}
	
	
	foreach($userarray as $uid=>$value)
	{
		$query = $db->simple_select("userfields", "*", "ufid='{$uid}'");
		$fields = $db->fetch_array($query);
		if(!$fields['ufid'])
		{
			$user_fields = array(
				'ufid' => $uid
			);

			$fields_array = $db->show_fields_from("userfields");
			foreach($fields_array as $field)
			{
				if($field['Field'] == 'ufid')
				{
					continue;
				}
				$user_fields[$field['Field']] = '';
			}
			$db->insert_query("userfields", $user_fields);
		}
		
		$update_fields = array
		(
			"fid1" => $db->escape_string($value),
		);
		$db->update_query("userfields", $update_fields, "ufid='{$uid}'");
	}
	$cache->update_profilefields();
}

function hp_listen_is_installed()
{
	global $db,$lang;
	
	$lang->load('hp_listen');
	
	$query = $db->simple_select('profilefields', '*', "name='".$lang->hp_listen_name_1."'");
    if ($db->num_rows($query)) {
       return true;
    }
    return false;
	
	
}

function hp_listen_uninstall()
{
	global $db,$cache;
	
	global $db;
	$query = $db->query("
		DROP TABLE ".TABLE_PREFIX."quidditch
	");
	
	global $db;
	$query = $db->query("
		DROP TABLE ".TABLE_PREFIX."spezials
	");
	
	global $db;
	$query = $db->query("
		DROP TABLE ".TABLE_PREFIX."multiava
	");
	
	$gquery = $db->simple_select("usergroups", "gid", "maingroupforlist>'0'");
	while($groups=$db->fetch_array($gquery))
	{
		$gid=$groups['gid'];
		
		$uquery = $db->simple_select("users", "uid, additionalgroups", "additionalgroups LIKE '%,".$gid."' OR additionalgroups LIKE '".$gid.",%' OR additionalgroups LIKE '%,".$gid.",%' OR additionalgroups LIKE '".$gid."'");
		while($users=$db->fetch_array($uquery))
		{
			$uid=$users['uid'];
			$oldusergroups=explode(',',$users['additionalgroups']);
			foreach($oldusergroups as $value)
			{
				if($value != $gid)
				{
					if(!$additionalgroups) $additionalgroups=$value;
					else $additionalgroups.=','.$value;
				}
			}
			
			if(!$additionalgroups) $additionalgroups="";
			
			$update_user = array(
			"additionalgroups" => $additionalgroups,
			);
			$db->update_query("users", $update_user, "uid='".$uid."'");
		}
		
		$db->delete_query('forumpermissions', "gid='{$gid}'");
		$db->delete_query('usergroups', "gid='{$gid}'");
	}
	
	$db->write_query("ALTER TABLE ".TABLE_PREFIX."usergroups DROP maingroupforlist");
	
	$query = $db->simple_select("profilefields", 'fid', "");
	while($row=$db->fetch_array($query))
	{
		$fid=$row['fid'];
		$db->delete_query("profilefields", "fid='{$fid}'");
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."userfields DROP fid{$fid}");
	}
	
	$db->write_query("ALTER TABLE ".TABLE_PREFIX."profilefields AUTO_INCREMENT=1");
	
	$cache->update_profilefields();
	
}

function hp_listen_register($uid=0)
{
	global $user, $user_info, $mybb, $db;
	
	if(!$uid || $uid==0)
	{
		if($user_info['uid']>0) $uid=$user_info['uid'];
		else $uid=$user['uid'];
	}
	
	
	$query = $db->simple_select("users","uid,vorlagegruppe,additionalgroups","uid='{$uid}'");
	$userinfo=$db->fetch_array($query);
	
	$query = $db->simple_select("usergroups", 'gid,maingroupforlist', "maingroupforlist>0");
	while($row=$db->fetch_array($query))
	{
		if($row['maingroupforlist']==1) $addultgroup=$row['gid'];
		if($row['maingroupforlist']==2) $studentgroup=$row['gid'];
	}
	
	
	if(!$userinfo['additionalgroups'] || $userinfo['additionalgroups']==$addultgroup || $userinfo['additionalgroups']==$studentgroup)
	{
			if($userinfo['vorlagegruppe']==1) $additionalgroup=$addultgroup;
			if($userinfo['vorlagegruppe']==2) $additionalgroup=$studentgroup;
			
	}
	else
	{
		$additionalgroups=explode(',',$userinfo['additionalgroups']);
		$i=0;
		foreach($additionalgroups as $group)
		{
			if($group!=$addultgroup && $group!=$studentgroup) 
			{
				if($i==0)
				{
					$i=1;
					$additionalgroup=$group;
				}
				else $additionalgroup.=','.$group;
			}
		}
		
		if($userinfo['vorlagegruppe']==1) $ngroup=$addultgroup;
		if($userinfo['vorlagegruppe']==2) $ngroup=$studentgroup;
		
		if(!$additionalgroup) $additionalgroup=$ngroup;
		else $additionalgroup.=','.$ngroup;
	}
	$update_user = array(
	"additionalgroups" => $additionalgroup
	);
	$db->update_query("users", $update_user, "uid='".$uid."'");
	
	if($userinfo['vorlagegruppe']==2) 
	{
		$ngroup=$addultgroup;
		$mgroup=$studentgroup;
	}
	if($userinfo['vorlagegruppe']==1)
	{
		$ngroup=$studentgroup;
		$mgroup=$addultgroup;
	}
	
	$query = $db->simple_select("profilefields","fid","(editableby LIKE '{$ngroup}' 
	OR editableby LIKE '%,{$ngroup}' 
	OR editableby LIKE '{$ngroup},%' 
	OR editableby LIKE '%,{$ngroup},%')
	AND editableby NOT LIKE '%,{$mgroup},%'
	AND editableby NOT LIKE '{$mgroup},%'
	AND editableby NOT LIKE '%,{$mgroup}'
	AND editableby NOT LIKE '{$mgroup}'");
	while($row=$db->fetch_array($query))
	{
		$fieldname="fid".$row['fid'];
		$db->query("UPDATE ".TABLE_PREFIX."userfields SET {$fieldname}='' WHERE ufid={$uid}");
	}
}

function wobgroup_global()
{
	global $mybb, $db;
	
	
	if($mybb->user['timeonline']<100)
	{
		hp_listen_register($mybb->user['uid']);
	}
}

function hp_listen_listcheck()
{
	global $db, $cache, $mybb, $_POST;
	$uid=$mybb->user['uid'];
	$pfcache = $cache->read('profilefields');
	
	$profile_fields = $mybb->get_input('profile_fields', MyBB::INPUT_ARRAY);
	
	foreach($pfcache as $profilefield)
	{
		$fid=$profilefield['fid'];
		$field = "fid{$fid}";
		if($profile_fields[$field])
		{
			if($fid==5)
			{
				$maxcount=1;
				$multi=1;
			}
			else if($fid==6)
			{
				$maxcount=1;
				$multi=0;
			}
			else if($fid==16)
			{
				$maxcount=1;
				$multi=0;
				$where=" AND fid14='{$profile_fields[fid14]}' AND fid1='{$profile_fields[fid1]}' AND fid14>4";
			}
			else if($fid==18)
			{
				$maxcount=1;
				$multi=1;
				$where=" AND fid13='{$profile_fields[fid13]}'";
			}
			else if($fid==21)
			{
				$value=ucwords($profile_fields[$field]);
				$aquery=$db->simple_select("multiava", "anzahl", "avaname='{$value}'");
				$multiavacounter = $db->fetch_array($aquery);
				
				$maxcount=$multiavacounter['anzahl'];
				$multi=0;
			}
			else $maxcount=0;
			
			if($maxcount>0)
			{
				if($multi==0)
				{
					$val=ucwords($profile_fields[$field]);
					
					$cquery = $db->query("SELECT COUNT(*) as count FROM " . TABLE_PREFIX . "userfields WHERE {$field}='{$val}' AND ufid<>'{$uid}'{$where}");
					$count = $db->fetch_field($cquery, "count"); 
					
					if($maxcount<$count || $maxcount==$count) $profile_fields[$field]='';
					else $profile_fields[$field]=$val;
				}
				else
				{
					$arr=$profile_fields[$field];
					
					if(is_array($arr))
					{
						foreach($arr as $name => $value)
						{
							$val=trim($value);
							if($fid==5)
							{
								$table="spezials";
								$column="spezial";
							}
							else if($fid==18)
							{
								$table="quidditch";
								$column="position";
							}
							
							
							$aquery = $db->simple_select($table, "*", "{$column}='{$val}'");
							$controll = $db->fetch_array($aquery);
							
							$maxcount = $controll['anzahl'];
							
							$cquery = $db->query("SELECT COUNT(*) as count FROM " . TABLE_PREFIX . "userfields WHERE {$field} LIKE '%{$val}%' AND ufid<>'{$uid}'{$where}");
							$count = $db->fetch_field($cquery, "count"); 
							
							if($maxcount<$count || $maxcount==$count) $arr[$name]='';
							else $arr[$name]=$val;
						}
					}
					else
					{
						$value=$arr;
						$val=trim($value);
						if($fid==5)
						{
							$table="spezials";
							$column="spezial";
						}
						else if($fid==18)
						{
							$table="quidditch";
							$column="position";
						}
						
						
						$aquery = $db->simple_select($table, "*", "{$column}='{$val}'");
						$controll = $db->fetch_array($aquery);
						
						$maxcount = $controll['anzahl'];
						
						$cquery = $db->query("SELECT COUNT(*) as count FROM " . TABLE_PREFIX . "userfields WHERE {$field} LIKE '%{$val}%' AND ufid<>'{$uid}'{$where}");
						$count = $db->fetch_field($cquery, "count"); 
						
						if($maxcount<$count || $maxcount==$count) $arr='';
						else $arr=$val;
					}
					
					$profile_fields[$field]=$arr;
					
				}
			}
			
			$mybb->input['profile_fields']=$profile_fields;
		}
	}
}
?>