<?php
// Main Plugin file for the plugin Colored Usernames
//  2014 - 2015 juventiner
// ----------------------------------------
// Last Update: 18.02.2015

if(!defined('IN_MYBB'))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

$plugins->add_hook('forumdisplay_announcement','colored_usernames_announcement');
$plugins->add_hook('forumdisplay_thread_end','colored_usernames_threads');

function colored_usernames_info()
{
	global $lang;
	$lang->load('colored_usernames');
	
	return array
	(
		'name'			=> $lang->colored_usernames_info_name,
		'description'	=> $lang->colored_usernames_info_desc,
		'website'		=> 'http://community.mybb.com/user-32469.html',
		'author'		=> 'juventiner',
		'authorsite'	=> 'https://www.mybboard.de/forum/user-5490.html',
		'version'		=> '1.3',
		'compatibility' => '16*,18*',
		'codename'      => 'coloredusernames'
	);
}


// This function runs when the plugin is activated.
function colored_usernames_activate()
{

	global $db, $lang;

	$insertarray = array(
		'name' => 'colored_usernames',
		'title' => $db->escape_string($lang->colored_usernames_settings_name),
		'description' => $db->escape_string($lang->colored_usernames_settings_desc),
		'disporder' => 35,
		'isdefault' => 0,
	);
	$gid = $db->insert_query("settinggroups", $insertarray);
	
	$insertarray = array(
		'name' => 'colored_usernames_status',
		'title' => $db->escape_string($lang->colored_usernames_settings_status_name),
		'description' => $db->escape_string($lang->colored_usernames_settings_status_desc),
		'optionscode' => 'yesno',
		'value' => 1,
		'disporder' => 1,
		'gid' => $gid
	);
	$db->insert_query("settings", $insertarray);

	rebuild_settings();

}

// This function runs when the plugin is deactivated.
function colored_usernames_deactivate(){

	global $db, $lang;
	$db->delete_query("settings", "name IN('colored_usernames_status')");
	$db->delete_query("settinggroups", "name IN('colored_usernames')");
}

function colored_usernames_announcement()
{
	global $db, $announcement, $mybb;
	
	//check if activated
	if($mybb->settings["colored_usernames_status"] == 1) {
		
		$query = $db->query("SELECT uid, usergroup, displaygroup FROM " . TABLE_PREFIX . "users WHERE username='" . $db->escape_string($announcement['username']) . "'");
		$user = $db->fetch_array($query);
        
		$formated_username = format_name($announcement['username'], $user['usergroup'], $user['displaygroup']);
		$formated_username = str_replace(array('<b>', '</b>', '<strong>', '</strong>'), array('', '', '', ''), $formated_username);
		$announcement['profilelink'] = build_profile_link($formated_username, $user['uid']);

	return $announcement;
	
	}
}

function colored_usernames_threads()
{
	global $db, $thread, $mybb;
	
	if($mybb->settings["colored_usernames_status"] == 1) {
	
		if(!$thread['username'])
		{
			$thread['username'] = $thread['threadusername'];
			$thread['profilelink'] = $thread['threadusername'];
		}
		else
		{
			$query = $db->query("SELECT uid, usergroup, displaygroup FROM " . TABLE_PREFIX . "users WHERE username='" . $db->escape_string($thread['username']) . "'");
			$user = $db->fetch_array($query);
    
		// Check if the User has moderation rights
		if (is_moderator($fid, "", $user['uid']))
		{
			$formated_username = format_name($thread['username'], $user['usergroup'], $user['displaygroup']);
			$formated_username = str_replace(array('<b>', '</b>', '<strong>', '</strong>'), array('', '', '', ''), $formated_username);
		}
		else
		{
			$formated_username = $thread['username'];
		}    
			$thread['profilelink'] = build_profile_link($formated_username, $thread['uid']);
		}
	}
}
?>
